define(["backdrop","appHeader","recordingFields","loading","imageLoader","listView","itemContextMenu","globalize","layoutManager","focusManager","apphost","cardBuilder","dom","appRouter","mediaInfo","connectionManager","itemHelper","datetime","inputManager","events","playbackManager","serverNotifications","baseView","emby-scroller","emby-itemscontainer","emby-linkbutton","emby-downloadbutton","flexStyles","detailButtonStyle","css!./item"],function(backdrop,appHeader,RecordingFields,loading,imageLoader,listView,itemContextMenu,globalize,layoutManager,focusManager,appHost,cardBuilder,dom,appRouter,mediaInfo,connectionManager,itemHelper,datetime,inputManager,events,playbackManager,serverNotifications,BaseView){"use strict";function renderTrackSelectionsWithoutUser(page,instance,item,forceReload){connectionManager.getApiClient(item.ServerId).getCurrentUser().then(function(user){renderTrackSelections(page,instance,item,user,forceReload)})}function intToString(value){try{return new Intl.NumberFormat(globalize.getCurrentLocales(),{style:"decimal"}).format(value)}catch(err){return console.log("Error in NumberFormat: "+err),value}}function createAttribute(label,value){return'<div class="flex"><span class="mediaInfoAttributeLabel">'+label+'</span><span class="mediaInfoAttributeValue">'+value+"</span></div>"}function getMediaSourceHtml(renderAdminFields,item,version,allMediaSources){var html="";html+='<div class="mediaSource">',version.Name&&1<allMediaSources.length&&(html+='<h2 style="margin-bottom:0;">'+version.Name+"</h2>"),html+='<div class="flex flex-direction-row align-items-flex-start flex-wrap-wrap">';for(var size,hasContent=!1,i=0,length=version.MediaStreams.length;i<length;i++){var streamTypeLocalizationKey,attributes,stream=version.MediaStreams[i];"Data"!==stream.Type&&(hasContent=!0,html+='<div class="mediaInfoStream">',streamTypeLocalizationKey="EmbeddedImage"===stream.Type?"Image":stream.Type,html+='<h3 class="mediaInfoStreamType">'+globalize.translate(streamTypeLocalizationKey)+"</h3>",attributes=[],stream.DisplayTitle&&attributes.push(createAttribute("Title",stream.DisplayTitle)),(stream.DisplayLanguage||stream.Language)&&"Video"!==stream.Type&&attributes.push(createAttribute(globalize.translate("Language"),stream.DisplayLanguage||stream.Language)),stream.Codec&&attributes.push(createAttribute(globalize.translate("Codec"),stream.Codec.toUpperCase())),stream.CodecTag&&attributes.push(createAttribute(globalize.translate("HeaderCodecTag"),stream.CodecTag)),null!=stream.IsAVC&&attributes.push(createAttribute("AVC",stream.IsAVC?globalize.translate("Yes"):globalize.translate("No"))),stream.Profile&&attributes.push(createAttribute(globalize.translate("Profile"),stream.Profile)),stream.Level&&attributes.push(createAttribute(globalize.translate("Level"),stream.Level)),(stream.Width||stream.Height)&&attributes.push(createAttribute(globalize.translate("Resolution"),stream.Width+"x"+stream.Height)),stream.AspectRatio&&"mjpeg"!==stream.Codec&&attributes.push(createAttribute(globalize.translate("HeaderAspectRatio"),stream.AspectRatio)),"Video"===stream.Type&&(null!=stream.IsAnamorphic&&attributes.push(createAttribute(globalize.translate("Anamorphic"),stream.IsAnamorphic?globalize.translate("Yes"):globalize.translate("No"))),attributes.push(createAttribute(globalize.translate("Interlaced"),stream.IsInterlaced?globalize.translate("Yes"):globalize.translate("No")))),(stream.AverageFrameRate||stream.RealFrameRate)&&attributes.push(createAttribute(globalize.translate("Framerate"),intToString(stream.AverageFrameRate||stream.RealFrameRate))),stream.ChannelLayout&&attributes.push(createAttribute(globalize.translate("Layout"),stream.ChannelLayout)),stream.Channels&&attributes.push(createAttribute(globalize.translate("Channels"),stream.Channels+" ch")),stream.BitRate&&"mjpeg"!==stream.Codec&&attributes.push(createAttribute(globalize.translate("Bitrate"),intToString(parseInt(stream.BitRate/1e3))+" kbps")),stream.SampleRate&&attributes.push(createAttribute(globalize.translate("HeaderSampleRate"),intToString(stream.SampleRate)+" Hz")),stream.VideoRange&&"SDR"!==stream.VideoRange&&attributes.push(createAttribute(globalize.translate("HeaderVideoRange"),stream.VideoRange)),stream.ColorPrimaries&&attributes.push(createAttribute(globalize.translate("HeaderColorPrimaries"),stream.ColorPrimaries)),stream.ColorSpace&&attributes.push(createAttribute(globalize.translate("HeaderColorSpace"),stream.ColorSpace)),stream.ColorTransfer&&attributes.push(createAttribute(globalize.translate("HeaderColorTransfer"),stream.ColorTransfer)),stream.BitDepth&&attributes.push(createAttribute(globalize.translate("HeaderBitDepth"),stream.BitDepth+" bit")),stream.PixelFormat&&attributes.push(createAttribute(globalize.translate("HeaderPixelFormat"),stream.PixelFormat)),stream.RefFrames&&attributes.push(createAttribute(globalize.translate("HeaderReferenceFrames"),stream.RefFrames)),stream.NalLengthSize&&attributes.push(createAttribute("NAL",stream.NalLengthSize)),"Video"!==stream.Type&&attributes.push(createAttribute(globalize.translate("Default"),stream.IsDefault?globalize.translate("Yes"):globalize.translate("No"))),"Subtitle"===stream.Type&&(attributes.push(createAttribute(globalize.translate("Forced"),stream.IsForced?globalize.translate("Yes"):globalize.translate("No"))),attributes.push(createAttribute(globalize.translate("External"),stream.IsExternal?globalize.translate("Yes"):globalize.translate("No")))),"Video"===stream.Type&&version.Timestamp&&attributes.push(createAttribute(globalize.translate("Timestamp"),version.Timestamp)),stream.Extradata&&attributes.push(createAttribute(globalize.translate("HeaderExtradata"),stream.Extradata)),html+=attributes.join(""),html+="</div>")}return html+="</div>",version.Container&&(hasContent=!0,html+=createAttribute(globalize.translate("Container"),version.Container)),version.Formats&&version.Formats.length&&(hasContent=!0,html+=createAttribute(globalize.translate("Format"),version.Formats.join(","))),version.Path&&"Http"!==version.Protocol&&renderAdminFields&&(hasContent=!0,html+=createAttribute(globalize.translate("Path"),version.Path)),version.Size&&(size=(version.Size/1048576).toFixed(0),hasContent=!0,html+=createAttribute(globalize.translate("Size"),size+"MB")),html+="</div>",hasContent?html:""}function renderMediaSources(page,renderAdminFields,item,mediaSources){var groupedVersions=mediaSources.filter(function(g){return"Grouping"===g.Type});renderAdminFields&&groupedVersions.length?page.querySelector(".splitVersionContainer").classList.remove("hide"):page.querySelector(".splitVersionContainer").classList.add("hide");var html=mediaSources.map(function(v){return getMediaSourceHtml(renderAdminFields,0,v,mediaSources)}).join("");(page.querySelector(".mediaSources").innerHTML=html)?page.querySelector(".audioVideoMediaInfo").classList.remove("hide"):page.querySelector(".audioVideoMediaInfo").classList.add("hide")}function renderTrackSelections(page,instance,item,user,forceReload){var select=page.querySelector(".selectSource");if(!itemHelper.supportsMediaSourceSelection(item)||-1===playbackManager.getSupportedCommands().indexOf("PlayMediaSource")||!playbackManager.canPlay(item))return renderMediaSources(page,user.Policy.IsAdministrator,0,item.MediaSources||[]),page.querySelector(".trackSelections").classList.add("hide"),select.innerHTML="",page.querySelector(".selectVideo").innerHTML="",page.querySelector(".selectAudio").innerHTML="",page.querySelector(".selectSubtitles").innerHTML="",select.setAttribute("disabled","disabled"),void updateTrackSelectionsFocusState(page);playbackManager.getPlaybackMediaSources(item).then(function(mediaSources){var renderAdminFields=user.Policy.IsAdministrator;renderMediaSources(page,renderAdminFields,0,mediaSources),instance._currentPlaybackMediaSources=mediaSources,page.querySelector(".trackSelections").classList.remove("hide"),select.setLabel(globalize.translate("LabelVersion"));var currentValue=select.value,selectedId=mediaSources[0].Id;select.innerHTML=mediaSources.map(function(v){var selected=v.Id===selectedId?" selected":"";return'<option value="'+v.Id+'"'+selected+">"+v.Name+"</option>"}).join(""),1<mediaSources.length?(select.removeAttribute("disabled"),page.querySelector(".selectSourceContainer").classList.remove("hide")):(page.querySelector(".selectSourceContainer").classList.add("hide"),select.setAttribute("disabled","disabled")),select.value===currentValue&&!forceReload||(renderVideoSelections(page,mediaSources),renderAudioSelections(page,mediaSources),renderSubtitleSelections(page,mediaSources),updateTrackSelectionsFocusState(page))})}function renderVideoSelections(page,mediaSources){var mediaSourceId=page.querySelector(".selectSource").value,tracks=mediaSources.filter(function(m){return m.Id===mediaSourceId})[0].MediaStreams.filter(function(m){return"Video"===m.Type}),select=page.querySelector(".selectVideo");select.setLabel(globalize.translate("LabelVideo"));var selectedId=tracks.length?tracks[0].Index:-1;select.innerHTML=tracks.map(function(v){var selected=v.Index===selectedId?" selected":"",titleParts=[],resolutionText=mediaInfo.getResolutionText(v);return resolutionText&&titleParts.push(resolutionText),v.Codec&&titleParts.push(v.Codec.toUpperCase()),'<option value="'+v.Index+'" '+selected+">"+(v.DisplayTitle||titleParts.join(" "))+"</option>"}).join(""),select.setAttribute("disabled","disabled"),tracks.length?page.querySelector(".selectVideoContainer").classList.remove("hide"):page.querySelector(".selectVideoContainer").classList.add("hide")}function renderAudioSelections(page,mediaSources){var mediaSourceId=page.querySelector(".selectSource").value,mediaSource=mediaSources.filter(function(m){return m.Id===mediaSourceId})[0],tracks=mediaSource.MediaStreams.filter(function(m){return"Audio"===m.Type}),select=page.querySelector(".selectAudio");select.setLabel(globalize.translate("LabelAudio"));var selectedId=mediaSource.DefaultAudioStreamIndex;select.innerHTML=tracks.map(function(v){var selected=v.Index===selectedId?" selected":"";return'<option value="'+v.Index+'" '+selected+">"+v.DisplayTitle+"</option>"}).join(""),1<tracks.length?select.removeAttribute("disabled"):select.setAttribute("disabled","disabled"),tracks.length?page.querySelector(".selectAudioContainer").classList.remove("hide"):page.querySelector(".selectAudioContainer").classList.add("hide")}function renderSubtitleSelections(page,mediaSources){var mediaSourceId=page.querySelector(".selectSource").value,mediaSource=mediaSources.filter(function(m){return m.Id===mediaSourceId})[0],tracks=mediaSource.MediaStreams.filter(function(m){return"Subtitle"===m.Type}),select=page.querySelector(".selectSubtitles");select.setLabel(globalize.translate("LabelSubtitles"));var selected,selectedId=null==mediaSource.DefaultSubtitleStreamIndex?-1:mediaSource.DefaultSubtitleStreamIndex;tracks.length?(selected=-1===selectedId?" selected":"",select.innerHTML='<option value="-1">'+globalize.translate("Off")+"</option>"+tracks.map(function(v){return selected=v.Index===selectedId?" selected":"",'<option value="'+v.Index+'" '+selected+">"+v.DisplayTitle+"</option>"}).join(""),select.classList.remove("noSelections"),page.querySelector(".selectSubtitlesContainer").classList.remove("hide")):(select.innerHTML="",select.classList.add("noSelections"),page.querySelector(".selectSubtitlesContainer").classList.add("hide"))}function setInnerHtml(page,query,html){for(var elems=page.querySelectorAll(query),i=0,length=elems.length;i<length;i++)elems[i].innerHTML=html}function setTitles(elems,title){for(var i=0,length=elems.length;i<length;i++)elems[i].title=title}function reloadPlayButtons(page,item,isUserDataChangeEvent){var now,activeElement,isPlayFocused,resumeText,canPlay=!1,playButtons=page.querySelectorAll(".btnPlay");return"Program"===item.Type?((now=new Date)>=datetime.parseISO8601Date(item.StartDate,!0)&&now<datetime.parseISO8601Date(item.EndDate,!0)?(hideAll(page,playButtons,!0),canPlay=!0):hideAll(page,playButtons),hideAll(page,"btnResume"),hideAll(page,"btnInstantMix"),hideAll(page,"btnShuffle"),hideAll(page,"btnQueue"),setTitles(playButtons,globalize.translate("Play"))):playbackManager.canPlay(item)?(hideAll(page,"btnPlay",!0),hideAll(page,"btnInstantMix",-1!==["Audio","MusicAlbum","MusicGenre","MusicArtist"].indexOf(item.Type)),hideAll(page,"btnShuffle",item.IsFolder||-1!==["MusicAlbum","MusicGenre","MusicArtist"].indexOf(item.Type)),canPlay=!0,isPlayFocused=(activeElement=document.activeElement)&&activeElement.classList&&(activeElement.classList.contains("btnResume")||activeElement.classList.contains("btnMainPlay")),"Series"===item.Type&&item.UserData&&item.UserData&&item.UserData.UnplayedItemCount?(hideAll(page,"btnResume",!0),page.querySelector(".resumeButtonText").innerHTML=globalize.translate("HeaderPlayNextUp"),setInnerHtml(page,".playButtonText",globalize.translate("HeaderPlayAll")),setTitles(playButtons,globalize.translate("HeaderPlayAll")),setTitles(page.querySelectorAll('.btnPlay[data-mode="resume"]'),globalize.translate("HeaderPlayNextUp"))):item.IsFolder?(setInnerHtml(page,".playButtonText",globalize.translate("HeaderPlayAll")),setTitles(playButtons,globalize.translate("HeaderPlayAll")),hideAll(page,"btnResume")):item.UserData&&0<item.UserData.PlaybackPositionTicks?(resumeText=globalize.translate("ResumeAt",datetime.getDisplayRunningTime(item.UserData.PlaybackPositionTicks)),page.querySelector(".resumeButtonText").innerHTML=resumeText,setInnerHtml(page,".playButtonText",globalize.translate("PlayFromBeginning")),setTitles(playButtons,globalize.translate("PlayFromBeginning")),setTitles(page.querySelectorAll('.btnPlay[data-mode="resume"]'),resumeText),hideAll(page,"btnResume",!0)):(setInnerHtml(page,".playButtonText",globalize.translate("Play")),setTitles(playButtons,globalize.translate("Play")),hideAll(page,"btnResume")),isUserDataChangeEvent||hideAll(page,"btnQueue",playbackManager.canQueue(item)),isPlayFocused&&focusMainSection.call(activeElement.parentNode)):(hideAll(page,playButtons),hideAll(page,"btnQueue"),hideAll(page,"btnResume"),hideAll(page,"btnInstantMix"),hideAll(page,"btnShuffle")),canPlay}function focusMainSection(){for(var btns=this.querySelectorAll(".detailButton"),i=0,length=btns.length;i<length;i++){var btn=btns[i];if(focusManager.isCurrentlyFocusable(btn))try{return void btn.focus()}catch(err){}}focusManager.autoFocus(this)}function logoImageUrl(item,apiClient,options){return(options=options||{}).type="Logo",item.ImageTags&&item.ImageTags.Logo?(options.tag=item.ImageTags.Logo,apiClient.getScaledImageUrl(item.Id,options)):item.ParentLogoImageTag?(options.tag=item.ParentLogoImageTag,apiClient.getScaledImageUrl(item.ParentLogoItemId,options)):null}function setTitle(item,apiClient,enableLogo){var pageTitle,url=enableLogo?logoImageUrl(item,apiClient,{}):null;url?((pageTitle=document.querySelector(".pageTitle")).style.backgroundImage="url('"+url+"')",pageTitle.classList.add("pageTitleWithLogo"),pageTitle.innerHTML=""):appHeader.setTitle("")}function renderLogo(page,item,apiClient){var url=logoImageUrl(item,apiClient,{maxWidth:300}),detailLogo=page.querySelector(".detailLogo"),detailLogoContainer=page.querySelector(".detailLogoContainer");url?(detailLogo.style.backgroundImage="url('"+url+"')",detailLogoContainer.classList.remove("hide")):detailLogoContainer.classList.add("hide")}function getArtistLinksHtml(artists,serverId,context){for(var html=[],i=0,length=artists.length;i<length;i++){var artist=artists[i],href=appRouter.getRouteUrl(artist,{context:context,itemType:"MusicArtist",serverId:serverId});html.push('<a style="color:inherit;font-weight:inherit;" class="button-link" is="emby-linkbutton" href="'+href+'">'+dom.htmlEncode(artist.Name)+"</a>")}return html=html.join(" / ")}function setTrailerButtonVisibility(page,item){(item.LocalTrailerCount||item.RemoteTrailers&&item.RemoteTrailers.length)&&-1!==playbackManager.getSupportedCommands().indexOf("PlayTrailers")?hideAll(page,"btnPlayTrailer",!0):hideAll(page,"btnPlayTrailer")}function renderImage(view,item){var detailImage=function(view,item){var sideImageContainer=view.querySelector(".detailImageContainer-side"),mainImageContainer=view.querySelector(".detailImageContainer-main");return enableTrackList(item)?(mainImageContainer.classList.add("hide"),sideImageContainer.classList.remove("hide"),sideImageContainer):(mainImageContainer.classList.remove("hide"),sideImageContainer.classList.add("hide"),mainImageContainer)}(view,item),cardClass="detailImageContainerCard";enableTrackList(item)||"Person"!==item.Type&&"MusicArtist"!==item.Type&&"BoxSet"!==item.Type&&"Season"!==item.Type||detailImage.classList.add("detailImageContainer-small");var isSide=detailImage.classList.contains("detailImageContainer-side");isSide&&(cardClass+=" detailImageContainerCard-side"),isSide?detailImage.classList.add("detailImageContainer-side"):(detailImage.classList.add("detailImageContainer-main"),layoutManager.tv&&detailImage.classList.add("detailImageContainer-main-tv")),1.33<=(item.PrimaryImageAspectRatio||1)?detailImage.classList.add("detailImageContainer-wide"):detailImage.classList.remove("detailImageContainer-wide"),cardBuilder.buildCards([item],{overlayText:!0,showTitle:!1,itemsContainer:detailImage,action:"none",imageClass:"detailImage",width:800,multiSelect:!1,moreButton:!1,ratingButton:!1,playedButton:!1,cardClass:cardClass,defaultIcon:!0,typeIndicator:!1,playedIndicator:!1,syncIndicator:!1,timerIndicator:!1,radiosity:!0,randomDefaultBackground:!1});var detailImageElement=detailImage.querySelector(".detailImage");detailImageElement&&(detailImage.querySelector(".cardImageIcon")?detailImageElement.classList.remove("detailImage-withImage"):detailImageElement.classList.add("detailImage-withImage"))}function enableTrackList(item){return"MusicAlbum"===item.Type||"Playlist"===item.Type}function hideAll(page,className,show){for(var elems="string"==typeof className?page.querySelectorAll("."+className):className,i=0,length=elems.length;i<length;i++)show?elems[i].classList.remove("hide"):elems[i].classList.add("hide")}function getContextMenuOptions(view,item,user,button){var selectSource=view.querySelector(".selectSource"),options={item:item,open:!1,play:!1,playAllFromHere:!1,queueAllFromHere:!1,positionTo:button,cancelTimer:!1,record:!1,deleteItem:!0===item.IsFolder,shuffle:!1,instantMix:!1,user:user,share:!0,mediaSourceId:selectSource&&selectSource.value||null,positionY:"bottom",positionX:"right"};return appHost.supports("sync")&&(options.syncLocal=!1),options}function fillOverview(elem,overview){var textElement=elem.querySelector(".overview-text");textElement.classList.remove("overview-text-full");var btnReadMore=elem.querySelector(".btnReadMore");if(setReadMoreText(btnReadMore,!1),!overview)return elem.classList.add("hide"),void(textElement.innerHTML="");textElement.innerHTML=overview,elem.classList.remove("hide");var offsetHeight=textElement.offsetHeight,scrollHeight=textElement.scrollHeight;offsetHeight&&scrollHeight&&offsetHeight<scrollHeight?(btnReadMore.classList.remove("hide"),setScopedFocus(null,elem,!0)):(btnReadMore.classList.add("hide"),setScopedFocus(null,elem,!1))}function renderDetails(instance,view,item,user,context){var overviewContent,overviewElem=view.querySelector(".overview-main"),sideOverviewElem=view.querySelector(".overview-side"),enableSideTrackList=enableTrackList(item);enableSideTrackList&&"Season"===item.Type?view.querySelector(".trackList").classList.add("seasonTrackList"):view.querySelector(".trackList").classList.remove("seasonTrackList"),enableSideTrackList?(view.querySelector(".detailLogo").classList.add("detailLogo-tracklist"),overviewElem.classList.add("overview-main-tracklist")):overviewElem.classList.remove("overview-main-tracklist"),!item.Overview||layoutManager.tv&&enableSideTrackList?(overviewElem.classList.add("hide"),sideOverviewElem.classList.add("hide")):(fillOverview(sideOverviewElem,overviewContent=item.Overview?dom.stripScripts(item.Overview):""),fillOverview(overviewElem,overviewContent),enableSideTrackList?overviewElem.classList.add("overview-main-autohide"):overviewElem.classList.remove("overview-main-autohide")),reloadPlayButtons(view,item),function(page,item){for(var btnPlaystates=page.querySelectorAll(".btnPlaystate"),i=0,length=btnPlaystates.length;i<length;i++){var btnPlaystate=btnPlaystates[i];itemHelper.canMarkPlayed(item)?(btnPlaystate.classList.remove("hide"),btnPlaystate.setItem(item)):(btnPlaystate.classList.add("hide"),btnPlaystate.setItem(null))}var btnUserRatings=page.querySelectorAll(".btnUserRating");for(i=0,length=btnUserRatings.length;i<length;i++){var btnUserRating=btnUserRatings[i];itemHelper.canRate(item)?(btnUserRating.classList.remove("hide"),btnUserRating.setItem(item)):(btnUserRating.classList.add("hide"),btnUserRating.setItem(null))}}(view,item),setTrailerButtonVisibility(view,item),item.CanDelete&&!item.IsFolder?hideAll(view,"btnDeleteItem",!0):hideAll(view,"btnDeleteItem"),function(instance,page,item,user){if(instance.currentRecordingFields)return instance.currentRecordingFields.refresh(item);var recordingFieldsElement=page.querySelector(".mainDetailButtons");"Program"===item.Type&&user.Policy.EnableLiveTvManagement&&(instance.currentRecordingFields=new RecordingFields({parent:recordingFieldsElement,program:item}),events.on(instance.currentRecordingFields,"recordingchanged",onRecordingChanged.bind(instance)),events.on(instance.currentRecordingFields,"seriesrecordingchanged",onRecordingChanged.bind(instance)))}(instance,view,item,user),itemContextMenu.getCommands(getContextMenuOptions(view,item,user)).length?hideAll(view,"btnMoreCommands",!0):hideAll(view,"btnMoreCommands");var mediaInfoElem=view.querySelector(".mediaInfoPrimary");"Season"===item.Type||"SeriesTimer"===item.Type?mediaInfoElem.classList.add("hide"):(mediaInfoElem.classList.remove("hide"),mediaInfo.fillPrimaryMediaInfo(mediaInfoElem,item,{interactive:!0,episodeTitle:!1,subtitles:!1,dateAdded:!0}),setScopedFocus(null,mediaInfoElem,null!=mediaInfoElem.querySelector("a,button"),"nearest")),mediaInfoElem=view.querySelector(".mediaInfoSecondary"),mediaInfo.fillSecondaryMediaInfo(mediaInfoElem,item,{interactive:!0}),setScopedFocus(null,mediaInfoElem,null!=mediaInfoElem.querySelector("a,button"),"nearest"),mediaInfoElem.innerHTML?mediaInfoElem.classList.remove("hide"):mediaInfoElem.classList.add("hide");var taglineElem=view.querySelector(".tagline");item.Taglines&&item.Taglines.length?(taglineElem.classList.remove("hide"),taglineElem.innerHTML=dom.stripScripts(item.Taglines[0])):taglineElem.classList.add("hide");var dateString,birthDateElem=view.querySelector(".birthDate");item.PremiereDate&&"Person"===item.Type?(birthDateElem.classList.remove("hide"),dateString=datetime.parseISO8601Date(item.PremiereDate).toDateString(),birthDateElem.innerHTML=globalize.translate("BornValue",dateString)):birthDateElem.classList.add("hide");var birthPlaceElem=view.querySelector(".birthPlace");"Person"===item.Type&&item.ProductionLocations&&item.ProductionLocations.length?(birthPlaceElem.classList.remove("hide"),birthPlaceElem.innerHTML=globalize.translate("BirthPlaceValue").replace("{0}",item.ProductionLocations[0])):birthPlaceElem.classList.add("hide"),function(page,item,context){var itemTags=page.querySelector(".itemTags"),tagElements=[],tags=item.TagItems||[];"Program"===item.Type&&(tags=[]);for(var i=0,length=tags.length;i<length;i++){var href=appRouter.getRouteUrl({Name:tags[i].Name,Type:"Tag",ServerId:item.ServerId,Id:tags[i].Id},{context:context,itemTypes:"Person"===item.Type||"MusicArtist"===item.Type?item.Type:null});tagElements.push('<a style="color:inherit;" is="emby-linkbutton" class="raised item-tag-button nobackdropfilter" href="'+href+'"><i class="md-icon button-icon button-icon-left">more</i>'+dom.htmlEncode(tags[i].Name)+"</a>")}itemTags.innerHTML=tagElements.join(""),tagElements.length?page.querySelector(".tagsSection").classList.remove("hide"):page.querySelector(".tagsSection").classList.add("hide")}(view,item,context)}function onRecordingChanged(){reloadItem(this,!0)}function renderNextUp(view,item){var seriesItem,options,apiClient,section=view.querySelector(".itemNextUpSection"),focusedItemIsNextUp=null!=dom.parentWithClass(document.activeElement,"itemNextUpSection");if("Series"!==item.Type)return section.classList.add("hide"),void(focusedItemIsNextUp&&focusManager.autoFocus(view));options={SeriesId:(seriesItem=item).Id,Fields:"PrimaryImageAspectRatio,CanDelete",ImageTypeLimit:1,EnableTotalRecordCount:!1,Limit:12},apiClient=connectionManager.getApiClient(seriesItem.ServerId),options.UserId=apiClient.getCurrentUserId(),apiClient.getNextUpEpisodes(options).then(function(result){!result.Items.length&&focusedItemIsNextUp&&focusManager.autoFocus(view),cardBuilder.buildCards(result.Items,{parentContainer:section,itemsContainer:section.querySelector(".itemsContainer"),shape:"autooverflow",showTitle:!0,overlayText:!1,centerText:!0,scalable:!0,autoFocus:focusedItemIsNextUp})})}function renderSeriesTimerSchedule(page,seriesTimerId,apiClient){apiClient.getLiveTvTimers({UserId:apiClient.getCurrentUserId(),ImageTypeLimit:1,EnableImageTypes:"Primary,Backdrop,Thumb",SortBy:"StartDate",EnableTotalRecordCount:!1,EnableUserData:!1,SeriesTimerId:seriesTimerId,Fields:"ChannelInfo,ChannelImage"}).then(function(result){result.Items.length&&result.Items[0].SeriesTimerId!==seriesTimerId&&(result.Items=[]);var html=function(items){var html="";return html+='<div is="emby-itemscontainer" class="itemsContainer vertical-list" data-contextmenu="false">',html+=listView.getListViewHtml(items,{enableUserDataButtons:!1,image:!0,imageSource:"channel",showProgramDateTime:!0,showChannel:!1,mediaInfo:!1,action:"none",moreButton:!1,recordButton:!1}),html+="</div>"}(result.Items),scheduleTab=page.querySelector(".seriesTimerSchedule");scheduleTab.innerHTML=html,imageLoader.lazyChildren(scheduleTab)})}function renderPeopleItems(view,item,apiClient){var section=view.querySelector(".peopleItems");if("Person"===item.Type||"MusicArtist"===item.Type){section.classList.remove("hide");var sections=[];"Person"===item.Type?(sections.push({name:globalize.translate("HeaderUpcomingOnTV"),type:"Program"}),sections.push({name:globalize.translate("Movies"),type:"Movie"}),sections.push({name:globalize.translate("Shows"),type:"Series"}),sections.push({name:globalize.translate("Episodes"),type:"Episode"}),sections.push({name:globalize.translate("Trailers"),type:"Trailer"}),sections.push({name:globalize.translate("HeaderMusicVideos"),type:"MusicVideo"}),sections.push({name:globalize.translate("Videos"),type:"Video"})):"MusicArtist"===item.Type&&sections.push({name:globalize.translate("HeaderMusicVideos"),type:"MusicVideo"}),section.innerHTML=sections.map(function(section){var html="";return html+='<div class="verticalSection personSection" data-type="'+section.type+'">',html+='<div class="sectionTitleContainer sectionTitleContainer-cards padded-left">',html+='<a is="emby-linkbutton" href="'+function(item,type){return"Genre"===item.Type?"list/list.html?type="+type+"&genreId="+item.Id+"&serverId="+item.ServerId:"MusicGenre"===item.Type?"list/list.html?type="+type+"&musicGenreId="+item.Id+"&serverId="+item.ServerId:"GameGenre"===item.Type?"list/list.html?type="+type+"&gameGenreId="+item.Id+"&serverId="+item.ServerId:"Studio"===item.Type?"list/list.html?type="+type+"&studioId="+item.Id+"&serverId="+item.ServerId:"MusicArtist"===item.Type?"list/list.html?type="+type+"&artistId="+item.Id+"&serverId="+item.ServerId:"Person"===item.Type?"list/list.html?type="+type+"&personId="+item.Id+"&serverId="+item.ServerId:"list/list.html?type="+type+"&parentId="+item.Id+"&serverId="+item.ServerId}(item,section.type)+'" class="button-link sectionTitleTextButton">',html+='<h2 class="sectionTitle sectionTitle-cards">',html+=section.name,html+='<i class="md-icon">&#xE5CC;</i></h2>',html+="</a>",html+="</div>",html+='<div is="emby-scroller" class="emby-scroller padded-top-focusscale padded-bottom-focusscale" data-mousewheel="false" data-centerfocus="true" data-horizontal="true">',html+='<div is="emby-itemscontainer" class="scrollSlider focuscontainer-x itemsContainer padded-left padded-right"></div>',html+="</div>",html+="</div>",html+="</div>"}).join("");for(var sectionElems=section.querySelectorAll(".personSection"),i=0,length=sectionElems.length;i<length;i++)!function(item,element,type,apiClient){switch(type){case"Program":loadPeopleItems(element,item,0,{IncludeItemTypes:"Program",Limit:12,SortBy:"StartDate",Fields:"PrimaryImageAspectRatio"},{shape:"autooverflow",showTitle:!0,centerText:!0,overlayMoreButton:!0,preferThumb:!0,overlayText:!1,showAirTime:!0,showAirDateTime:!0,showChannelName:!0},apiClient);break;case"Movie":loadPeopleItems(element,item,0,{IncludeItemTypes:"Movie",Limit:12,SortBy:"SortName",Fields:"PrimaryImageAspectRatio"},{shape:"autooverflow",showTitle:!0,centerText:!0,overlayMoreButton:!0,overlayText:!1,showYear:!0},apiClient);break;case"Video":loadPeopleItems(element,item,0,{IncludeItemTypes:"Video",Limit:12,SortBy:"SortName",Fields:"PrimaryImageAspectRatio"},{shape:"autooverflow",showTitle:!0,centerText:!0,overlayMoreButton:!0,overlayText:!1,showYear:!0},apiClient);break;case"MusicVideo":loadPeopleItems(element,item,0,{IncludeItemTypes:"MusicVideo",Limit:12,SortBy:"SortName",Fields:"PrimaryImageAspectRatio"},{shape:"autooverflow",showTitle:!0,centerText:!0,overlayPlayButton:!0},apiClient);break;case"Game":loadPeopleItems(element,item,0,{IncludeItemTypes:"Game",Limit:12,SortBy:"SortName",Fields:"PrimaryImageAspectRatio"},{shape:"autooverflow",showTitle:!0,centerText:!0,overlayMoreButton:!0},apiClient);break;case"Trailer":loadPeopleItems(element,item,0,{IncludeItemTypes:"Trailer",Limit:12,SortBy:"SortName",Fields:"PrimaryImageAspectRatio"},{shape:"autooverflow",showTitle:!0,centerText:!0,overlayPlayButton:!0},apiClient);break;case"Series":loadPeopleItems(element,item,0,{IncludeItemTypes:"Series",Limit:12,SortBy:"SortName",Fields:"PrimaryImageAspectRatio"},{shape:"autooverflow",showTitle:!0,centerText:!0,overlayMoreButton:!0},apiClient);break;case"MusicAlbum":loadPeopleItems(element,item,0,{IncludeItemTypes:"MusicAlbum",Limit:12,SortBy:"ProductionYear,SortName",SortOrder:"Descending,Ascending",Fields:"ProductionYear,PrimaryImageAspectRatio"},{shape:"autooverflow",playFromHere:!0,showTitle:!0,showYear:!0,centerText:!0,overlayPlayButton:!0},apiClient);break;case"MusicArtist":loadPeopleItems(element,item,0,{IncludeItemTypes:"MusicArtist",Limit:8,SortBy:"SortName",Fields:"PrimaryImageAspectRatio"},{shape:"autooverflow",playFromHere:!0,showTitle:!0,showParentTitle:!0,centerText:!0,overlayPlayButton:!0},apiClient);break;case"Episode":loadPeopleItems(element,item,0,{IncludeItemTypes:"Episode",Limit:6,SortBy:"SeriesSortName,SortName",Fields:"PrimaryImageAspectRatio"},{shape:"autooverflow",showTitle:!0,showParentTitle:!0,centerText:!0,overlayPlayButton:!0},apiClient);break;case"Audio":loadPeopleItems(element,item,0,{IncludeItemTypes:"Audio",SortBy:"AlbumArtist,Album,SortName",Fields:"PrimaryImageAspectRatio"},{playFromHere:!0,action:"playallfromhere",smallIcon:!0,artist:!0},apiClient)}}(item,sectionElems[i],sectionElems[i].getAttribute("data-type"),apiClient)}else section.classList.add("hide")}function loadPeopleItems(element,item,type,query,listOptions,apiClient){query.SortBy="SortName",query.SortOrder="Ascending",query.Recursive=!0,query.CollapseBoxSetItems=!1,query.Fields="PrimaryImageAspectRatio,ProductionYear","Person"===item.Type?query.PersonIds=item.Id:"MusicArtist"===item.Type&&(query.ArtistIds=item.Id),query.ImageTypeLimit=1,query.EnableTotalRecordCount=!1,apiClient.getItems(apiClient.getCurrentUserId(),query).then(function(result){cardBuilder.buildCards(result.Items,{parentContainer:element,itemsContainer:element.querySelector(".itemsContainer"),shape:listOptions.shape,showTitle:listOptions.showTitle,showYear:listOptions.showYear,showParentTitle:listOptions.showParentTitle,overlayText:!1,centerText:!0})})}function renderChannelGuide(page,apiClient,item){"TvChannel"===item.Type&&(page.querySelector(".programGuideSection").classList.remove("hide"),apiClient.getLiveTvPrograms({ChannelIds:item.Id,UserId:apiClient.getCurrentUserId(),HasAired:!1,SortBy:"StartDate",EnableTotalRecordCount:!1,EnableImages:!1,ImageTypeLimit:0,EnableUserData:!1}).then(function(result){!function(page,result){for(var html="",currentItems=[],currentStartDate=null,i=0,length=result.Items.length;i<length;i++){var item=result.Items[i],itemStartDate=datetime.parseISO8601Date(item.StartDate);currentStartDate&&currentStartDate.toDateString()===itemStartDate.toDateString()||(currentItems.length&&(html+='<div class="verticalSection verticalDetailSection">',html+='<h2 class="sectionTitle padded-left">'+datetime.toLocaleDateString(currentStartDate,{weekday:"long",month:"long",day:"numeric"})+"</h2>",html+='<div is="emby-itemscontainer" class="vertical-list padded-left padded-right">'+listView.getListViewHtml(currentItems,{enableUserDataButtons:!1,showParentTitle:!0,image:!1,showProgramTime:!0,mediaInfo:!1,parentTitleWithTitle:!0})+"</div></div>"),currentStartDate=itemStartDate,currentItems=[]),currentItems.push(item)}currentItems.length&&(html+='<div class="verticalSection verticalDetailSection">',html+='<h2 class="sectionTitle padded-left">'+datetime.toLocaleDateString(currentStartDate,{weekday:"long",month:"long",day:"numeric"})+"</h2>",html+='<div is="emby-itemscontainer" class="vertical-list padded-left padded-right">'+listView.getListViewHtml(currentItems,{enableUserDataButtons:!1,showParentTitle:!0,image:!1,showProgramTime:!0,mediaInfo:!1,parentTitleWithTitle:!0})+"</div></div>"),page.querySelector(".programGuide").innerHTML=html}(page,result)}))}function renderEpisodes(view,item,apiClient){var section=view.querySelector(".trackList");"Season"===item.Type?apiClient.getEpisodes(item.SeriesId,{SeasonId:item.Id,ImageTypeLimit:1,UserId:apiClient.getCurrentUserId(),Fields:"Overview,PrimaryImageAspectRatio"}).then(function(result){result.Items.length?(section.classList.remove("hide"),section.innerHTML=listView.getListViewHtml(result.Items,{showIndexNumber:"MusicAlbum"===item.Type,enableOverview:!0,imageSize:"large",enableSideMediaInfo:!1,highlight:!1,action:layoutManager.tv?null:"none",infoButton:!layoutManager.tv,imagePlayButton:!layoutManager.tv,includeParentInfoInTitle:!1,enableSpecialEpisodePrefix:0!==item.IndexNumber}),imageLoader.lazyChildren(section),setTimeout(function(){!function(items,element){var focusItem=items.filter(function(i){return!i.UserData||!i.UserData.Played})[0];focusItem=focusItem||items[0];{var itemElement;focusItem&&(itemElement=element.querySelector("*[data-id='"+focusItem.Id+"']"),focusManager.focus(itemElement))}}(result.Items,section)},100)):section.classList.add("hide")}):section.classList.add("hide")}function renderChildren(view,item,apiClient){!function(view,item,apiClient){var onItemsResult,section=view.querySelector(".trackList");enableTrackList(item)?(onItemsResult=function(result){if(!result.Items.length)return section.classList.add("hide"),void focusManager.autoFocus(view);section.classList.remove("hide"),"Playlist"===item.Type&&(layoutManager.tv||section.enableDragReordering(!0)),section.innerHTML=listView.getListViewHtml(result.Items,{showIndexNumberLeft:"MusicAlbum"===item.Type,action:"playallfromhere",dragHandle:"Playlist"===item.Type&&!layoutManager.tv,playlistId:"Playlist"===item.Type?item.Id:null,image:"Playlist"===item.Type,artist:"auto",showIndex:"MusicAlbum"===item.Type,index:"disc",containerAlbumArtists:item.AlbumArtists,addToListButton:!0,showParentTitle:"Playlist"===item.Type}),imageLoader.lazyChildren(section),focusManager.autoFocus(section)},"MusicAlbum"===item.Type?apiClient.getItems(apiClient.getCurrentUserId(),{ParentId:item.Id,Fields:"PrimaryImageAspectRatio,CanDelete",ImageTypeLimit:1,SortBy:null,EnableTotalRecordCount:!1}).then(onItemsResult):"Playlist"===item.Type&&apiClient.getItems(apiClient.getCurrentUserId(),{ParentId:item.Id,Fields:"PrimaryImageAspectRatio",ImageTypeLimit:1}).then(onItemsResult)):section.classList.add("hide")}(view,item,apiClient),renderEpisodes(view,item,apiClient),renderChannelGuide(view,apiClient,item),renderPeopleItems(view,item,apiClient);var userId,itemsContainer,cardOptions,query,section=view.querySelector(".childrenSection");"Series"===item.Type||"MusicArtist"===item.Type||"BoxSet"===item.Type?(userId=apiClient.getCurrentUserId(),itemsContainer=section.querySelector(".itemsContainer"),cardOptions={parentContainer:section,itemsContainer:itemsContainer,shape:"auto",scalable:!0,collectionId:"BoxSet"===item.Type?item.Id:null,centerText:!0,showTitle:!0,overlayText:!1,showYear:"BoxSet"===item.Type},("MusicArtist"===item.Type?(query={IncludeItemTypes:"MusicAlbum",Recursive:!0,SortBy:"ProductionYear,SortName",SortOrder:"Descending,Ascending",ImageTypeLimit:1,Fields:"PrimaryImageAspectRatio,ProductionYear,CanDelete",EnableTotalRecordCount:!1,AlbumArtistIds:item.Id},cardOptions.showYear=!0,apiClient.getItems(apiClient.getCurrentUserId(),query)):"Series"===item.Type?apiClient.getSeasons(item.Id,{UserId:userId,Fields:"PrimaryImageAspectRatio,BasicSyncInfo,CanDelete,ProductionYear",EnableTotalRecordCount:!1}):apiClient.getItems(apiClient.getCurrentUserId(),{ParentId:item.Id,ImageTypeLimit:1,Fields:"PrimaryImageAspectRatio,ProductionYear,CanDelete",EnableTotalRecordCount:!1})).then(function(result){result.Items.length?(section.classList.remove("hide"),cardBuilder.buildCards(result.Items,cardOptions)):section.classList.add("hide")})):section.classList.add("hide")}function onTrackSelectionsSubmit(e){return e.preventDefault(),!1}function bindAll(view,selector,eventName,fn){for(var elems=view.querySelectorAll(selector),i=0,length=elems.length;i<length;i++)elems[i].addEventListener(eventName,fn)}function onInputCommand(e){switch(e.detail.command){case"play":playCurrentItem(this,"resume");break;case"record":!function(instance){var currentItem=instance.currentItem,type=currentItem.Type,id=currentItem.Id,serverId=currentItem.ServerId,timerId=currentItem.TimerId,seriesTimerId=currentItem.SeriesTimerId;("Program"===type||timerId||seriesTimerId)&&require(["recordingHelper"],function(recordingHelper){var programId="Program"===type?id:null;recordingHelper.toggle(serverId,programId,timerId,seriesTimerId).then(function(){reloadItem(instance,!0)})})}(this);break;default:return}e.preventDefault(),e.stopPropagation()}function startDataLoad(instance){var params=instance.params,apiClient=connectionManager.getApiClient(params.serverId);instance.dataPromises=[function(instance,apiClient){var params=instance.params;return params.seriesTimerId?apiClient.getLiveTvSeriesTimer(params.seriesTimerId):apiClient.getItem(apiClient.getCurrentUserId(),params.id)}(instance,apiClient),apiClient.getCurrentUser()]}function getPlayOptions(view,startPositionTicks){var audioStreamIndex=view.querySelector(".selectAudio").value||null;return{startPositionTicks:startPositionTicks,mediaSourceId:view.querySelector(".selectSource").value,audioStreamIndex:audioStreamIndex,subtitleStreamIndex:view.querySelector(".selectSubtitles").value}}function playCurrentItem(instance,mode){var item=instance.currentItem,playOptions=getPlayOptions(instance.view,item.UserData&&"resume"===mode?null:0);playOptions.items=[item],playbackManager.play(playOptions)}function onPlayClick(e){playCurrentItem(this,e.currentTarget.getAttribute("data-mode"))}function onQueueClick(){var text,currentItem=this.currentItem;playbackManager.queue({items:[currentItem]}),text=globalize.translate("AddedToPlayQueue"),require(["toast"],function(toast){toast(text)})}function onEdited(){reloadItem(this,!0)}function onEditCancel(){}function onEditMetadataClick(){var currentItem=this.currentItem,instance=this;require(["metadataEditor"]).then(function(responses){return responses[0].show(currentItem.Id,currentItem.ServerId).then(onEdited.bind(instance),onEditCancel)})}function onEditImagesClick(){var currentItem=this.currentItem,instance=this;require(["imageEditor"],function(imageEditor){imageEditor.show({itemId:currentItem.Id,serverId:currentItem.ServerId}).then(onEdited.bind(instance),onEditCancel)})}function onDownloadChange(){reloadItem(this,!0)}function setReadMoreText(btn,isExpanded){var text="";isExpanded?(text=globalize.translate("HeaderReadLess"),layoutManager.tv||(text+='<i class="md-icon" style="font-size:1.3em;">arrow_drop_up</i>')):(text=globalize.translate("HeaderReadMore"),layoutManager.tv||(text+='<i class="md-icon" style="font-size:1.3em;">arrow_drop_down</i>')),btn.innerHTML=text}function onReadMoreClick(e){var btn=e.currentTarget,overviewTextElem=btn.parentNode.querySelector(".overview-text");overviewTextElem.classList.contains("overview-text-full")?(overviewTextElem.classList.remove("overview-text-full"),setReadMoreText(btn,!1)):(overviewTextElem.classList.add("overview-text-full"),setReadMoreText(btn,!0))}function onSplitVersionsClick(){var params=this.params,apiClient=connectionManager.getApiClient(params.serverId);!function(instance,apiClient,params){require(["confirm"],function(confirm){confirm("Are you sure you wish to split the media sources into separate items?","Split Media Apart").then(function(){loading.show(),apiClient.ajax({type:"DELETE",url:apiClient.getUrl("Videos/"+params.id+"/AlternateSources")}).then(function(){loading.hide(),reloadItem(instance,!0)})})})}(this,(this.view,apiClient),params)}function reloadItem(instance,reloadAllData,restartDataLoad){reloadAllData&&!1!==restartDataLoad&&startDataLoad(instance),Promise.all(instance.dataPromises).then(function(responses){var item=responses[0],user=responses[1];instance.currentItem=item;var apiClient=connectionManager.getApiClient(item.ServerId);!function(instance,item,apiClient){if(!instance.childrenSectionInit){var sectionType;instance.childrenSectionInit=!0;var section=instance.view.querySelector(".childrenSection");if("Series"===item.Type||"MusicArtist"===item.Type)sectionType="x";else{if("BoxSet"!==item.Type)return section.classList.add("hide");sectionType="y"}var focusableType,html="";"x"===sectionType?(html+='<div class="sectionTitleContainer sectionTitleContainer-cards padded-left padded-right">',html+="</div>",html+='<div is="emby-scroller" class="emby-scroller padded-top-focusscale padded-bottom-focusscale" data-mousewheel="false" data-centerfocus="true" data-horizontal="true">',html+='<div is="emby-itemscontainer" class="scrollSlider focuscontainer-x itemsContainer padded-left padded-right focusable"></div>',html+="</div>"):"y"===sectionType&&(html+='<h2 class="sectionTitle sectionTitle-cards padded-left padded-right"></h2>',html+='<div is="emby-itemscontainer" class="itemsContainer vertical-wrap childrenItemsContainer focuscontainer-x padded-left padded-right"></div>'),section.innerHTML=html,"x"===sectionType&&(focusableType="Series"===item.Type?"autofocus":"nearest",setScopedFocus(instance.view,section.querySelector(".focusable"),!0,focusableType));var headerText,headerHtml,childrenItemsContainer=section.querySelector(".childrenItemsContainer");childrenItemsContainer&&(childrenItemsContainer.refreshItems=onFullReloadNeeded.bind(instance)),"Series"===item.Type?(headerText=section.querySelector(".sectionTitleContainer"),headerHtml='<h2 class="sectionTitle sectionTitle-cards">',headerHtml+=globalize.translate("Seasons"),headerHtml+="</h2>",headerText.innerHTML=headerHtml,headerText.classList.remove("hide")):"MusicArtist"===item.Type?(headerText=section.querySelector(".sectionTitleContainer"),headerHtml='<a is="emby-linkbutton" href="'+appRouter.getRouteUrl("list",{serverId:apiClient.serverId(),itemTypes:"MusicAlbum",albumArtistId:item.Id})+'" class="button-link sectionTitleTextButton">',headerHtml+='<h2 class="sectionTitle sectionTitle-cards">',headerHtml+=globalize.translate("Albums"),headerHtml+='<i class="md-icon">&#xE5CC;</i></h2>',headerHtml+="</a>",headerText.innerHTML=headerHtml,headerText.classList.remove("hide")):"BoxSet"===item.Type&&((headerText=section.querySelector("h2")).innerHTML=globalize.translate("Items"),headerText.classList.remove("hide"))}}(instance,item,apiClient),"Person"===item.Type&&backdrop.hasBackdrop()||backdrop.setBackdrops([item]);var mainSection,topDetailsContainer,topDetailsMain,itemSideContainer,backgroundContainer,mainDetailButtons,view=instance.view;enableTrackList(item)?"Season"===item.Type?setTitle(item,apiClient):layoutManager.tv?setTitle(item,apiClient,layoutManager.tv):(renderLogo(view,item,apiClient),setTitle(item,apiClient)):(renderLogo(view,item,apiClient),setTitle(item,apiClient)),reloadAllData&&(mainSection=view.querySelector(".detailMainContainer"),topDetailsContainer=view.querySelector(".topDetailsContainer"),topDetailsMain=view.querySelector(".topDetailsMain"),itemSideContainer=view.querySelector(".item-fixed-side"),backgroundContainer=document.querySelector(".backgroundContainer"),enableTrackList(item)?(topDetailsMain.classList.remove("topDetailsMain-graphic"),backgroundContainer.classList.remove("itemBackgroundContainer-graphic"),mainSection.classList.remove("padded-bottom"),layoutManager.tv&&"Season"!==item.Type?(itemSideContainer.classList.remove("padded-left"),topDetailsContainer.classList.add("flex-direction-row-reverse"),topDetailsContainer.classList.remove("flex-direction-row")):(itemSideContainer.classList.remove("padded-right"),topDetailsContainer.classList.remove("flex-direction-row-reverse"),topDetailsContainer.classList.add("flex-direction-row")),itemSideContainer.classList.remove("hide"),layoutManager.tv&&"Season"!==item.Type?(topDetailsMain.classList.add("padded-left"),topDetailsMain.classList.add("padded-right")):(topDetailsMain.classList.remove("padded-left"),topDetailsMain.classList.remove("padded-right"))):(layoutManager.tv&&("Series"===item.Type||"Video"===item.MediaType||"Game"===item.MediaType)&&(item.BackdropImageTags&&item.BackdropImageTags.length||item.ParentBackdropImageTags&&item.ParentBackdropImageTags.length)?(topDetailsMain.classList.add("topDetailsMain-graphic"),backgroundContainer.classList.add("itemBackgroundContainer-graphic"),mainSection.classList.remove("padded-bottom")):(mainSection.classList.add("padded-bottom"),topDetailsMain.classList.remove("topDetailsMain-graphic"),backgroundContainer.classList.remove("itemBackgroundContainer-graphic")),itemSideContainer.classList.add("hide"),(mainDetailButtons=view.querySelector(".mainDetailButtons")).classList.remove("mainDetailButtons-autohide"),topDetailsMain.classList.remove("padded-left"),topDetailsMain.classList.remove("padded-right"),function(elem){for(var btns=elem.querySelectorAll(".detailButton"),i=0,length=btns.length;i<length;i++){var btn=btns[i];if(focusManager.isCurrentlyFocusable(btn))return setScopedFocus(null,elem,!0)}setScopedFocus(null,elem,!1)}(mainDetailButtons)),function(instance,item,user,containers,context){var parentRoute,parentNameHtml=[],parentNameLast=!1,hasButton=!1;item.AlbumArtists?(parentNameHtml.push(getArtistLinksHtml(item.AlbumArtists,item.ServerId,context)),parentNameLast=!0):item.ArtistItems&&item.ArtistItems.length&&"MusicVideo"===item.Type?(parentNameHtml.push(getArtistLinksHtml(item.ArtistItems,item.ServerId,context)),parentNameLast=!0):item.SeriesName&&item.SeriesId?(parentRoute=appRouter.getRouteUrl({Id:item.SeriesId,Name:item.SeriesName,Type:"Series",IsFolder:!0,ServerId:item.ServerId},{context:context}),hasButton=!0,parentNameHtml.push('<a style="color:inherit;font-weight:inherit;" class="button-link" is="emby-linkbutton" href="'+parentRoute+'">'+dom.htmlEncode(item.SeriesName)+"</a>")):item.SeriesName?parentNameHtml.push(dom.htmlEncode(item.SeriesName)):(item.IsSeries||item.EpisodeTitle)&&parentNameHtml.push(dom.htmlEncode(item.Name)),item.SeasonId&&item.SeasonName?(parentRoute=appRouter.getRouteUrl({Id:item.SeasonId,Name:item.SeasonName,Type:"Season",IsFolder:!0,ServerId:item.ServerId},{context:context}),hasButton=!0,parentNameHtml.push('<a style="color:inherit;font-weight:inherit;" class="button-link" is="emby-linkbutton" href="'+parentRoute+'">'+dom.htmlEncode(item.SeasonName)+"</a>")):item.SeasonName?parentNameHtml.push(dom.htmlEncode(item.SeasonName)):item.Album&&item.AlbumId&&("MusicVideo"===item.Type||"Audio"===item.Type)?(parentRoute=appRouter.getRouteUrl({Id:item.AlbumId,Name:item.Album,Type:"MusicAlbum",IsFolder:!0,ServerId:item.ServerId},{context:context}),hasButton=!0,parentNameHtml.push('<a style="color:inherit;font-weight:inherit;" class="button-link" is="emby-linkbutton" href="'+parentRoute+'">'+dom.htmlEncode(item.Album)+"</a>")):item.Album&&parentNameHtml.push(dom.htmlEncode(item.Album));var html="",editorButtonsHtml="";layoutManager.tv||(itemHelper.canEdit(user,item)&&(hasButton=!0,editorButtonsHtml+='<button is="paper-icon-button-light" class="btnDetailEdit btnEditMetadata secondaryText flex-shrink-zero" title="'+globalize.translate("HeaderEditMetadata")+'"><i class="md-icon">edit</i></button>'),itemHelper.canEditImages(user,item)&&(hasButton=!0,editorButtonsHtml+='<button is="paper-icon-button-light" class="btnDetailEdit btnEditImages secondaryText flex-shrink-zero" title="'+globalize.translate("HeaderEditImages")+'"><i class="md-icon">photo</i></button>')),parentNameHtml.length&&(html=parentNameLast?'<div class="itemSecondaryNameContainer"><h3 class="itemName-secondary">'+parentNameHtml.join(" - ")+"</h3></div>":'<div class="itemPrimaryNameContainer"><h1 class="itemName-primary">'+parentNameHtml.join(" - ")+"</h1></div>");var name=itemHelper.getDisplayName(item,{includeParentInfo:!1});html&&!parentNameLast?html+='<div class="flex align-items-center flex-wrap-wrap itemSecondaryNameContainer"><h3 class="itemName-secondary">'+name+"</h3>"+editorButtonsHtml+"</div>":html=parentNameLast?'<div class="flex align-items-center flex-wrap-wrap itemPrimaryNameContainer"><h1 class="itemNameBeforeParentName itemName-primary">'+name+"</h1>"+editorButtonsHtml+"</div>"+html:'<div class="flex align-items-center flex-wrap-wrap itemPrimaryNameContainer"><h1 class="itemName-primary">'+name+"</h1>"+editorButtonsHtml+"</div>"+html;for(var i=0,length=containers.length;i<length;i++){var container=containers[i];container.innerHTML=html,setScopedFocus(null,container,hasButton,"nearest"),html.length?container.classList.remove("hide"):container.classList.add("hide");var btnEditMetadata=container.querySelector(".btnEditMetadata");btnEditMetadata&&btnEditMetadata.addEventListener("click",onEditMetadataClick.bind(instance));var btnEditImages=container.querySelector(".btnEditImages");btnEditImages&&btnEditImages.addEventListener("click",onEditImagesClick.bind(instance))}}(instance,item,user,view.querySelectorAll(".nameContainer"),void 0),renderImage(view,item),renderDetails(instance,view,item,user,void 0),function(view,item,context){context=context||function(item){return"Movie"===item.Type||"BoxSet"===item.Type?"movies":"Series"===item.Type||"Season"===item.Type||"Episode"===item.Type?"tvshows":"Game"===item.Type||"GameSystem"===item.Type||"Game"===item.Type||"GameSystem"===item.Type?"games":"MusicArtist"===item.Type||"MusicAlbum"===item.Type||"Audio"===item.Type||"AudioBook"===item.Type?"music":null}(item);var type,genres=item.GenreItems||[];switch(context){case"games":type="GameGenre";break;case"music":type="MusicGenre";break;default:type="Genre"}var html=genres.map(function(p){return'<a style="color:inherit;" class="button-link" is="emby-linkbutton" href="'+appRouter.getRouteUrl({Name:p.Name,Type:type,ServerId:item.ServerId,Id:p.Id},{context:context})+'">'+dom.htmlEncode(p.Name)+"</a>"}).join(", "),elem=view.querySelector(".genres");elem.innerHTML=html,genres.length?elem.classList.remove("hide"):elem.classList.add("hide")}(view,item,void 0),function(page,item,apiClient){var imgUrl,screenWidth=screen.availWidth,itemBackdropElement=page.querySelector("#itemBackdrop"),usePrimaryImage="Video"===item.MediaType&&"Movie"!==item.Type&&"Trailer"!==item.Type||item.MediaType&&"Video"!==item.MediaType||"MusicAlbum"===item.Type;"Program"===item.Type&&item.ImageTags&&item.ImageTags.Thumb?imgUrl=apiClient.getScaledImageUrl(item.Id,{type:"Thumb",index:0,maxWidth:screenWidth,tag:item.ImageTags.Thumb}):usePrimaryImage&&item.ImageTags&&item.ImageTags.Primary?imgUrl=apiClient.getScaledImageUrl(item.Id,{type:"Primary",index:0,maxWidth:screenWidth,tag:item.ImageTags.Primary}):item.BackdropImageTags&&item.BackdropImageTags.length?imgUrl=apiClient.getScaledImageUrl(item.Id,{type:"Backdrop",index:0,maxWidth:screenWidth,tag:item.BackdropImageTags[0]}):item.ParentBackdropItemId&&item.ParentBackdropImageTags&&item.ParentBackdropImageTags.length?imgUrl=apiClient.getScaledImageUrl(item.ParentBackdropItemId,{type:"Backdrop",index:0,tag:item.ParentBackdropImageTags[0],maxWidth:screenWidth}):item.ImageTags&&item.ImageTags.Thumb?imgUrl=apiClient.getScaledImageUrl(item.Id,{type:"Thumb",index:0,maxWidth:screenWidth,tag:item.ImageTags.Thumb}):item.ImageTags&&item.ImageTags.Primary&&(imgUrl=apiClient.getScaledImageUrl(item.Id,{type:"Primary",index:0,maxWidth:screenWidth,tag:item.ImageTags.Primary})),"Person"===item.Type?itemBackdropElement.classList.add("itemBackrop-contain"):itemBackdropElement.classList.remove("itemBackrop-contain"),itemBackdropElement.style.backgroundImage=imgUrl?"url('"+imgUrl+"')":""}(view,item,apiClient),function(page,item,context){var directors=(item.People||[]).filter(function(p){return"Director"===p.Type}),html=directors.map(function(p){return'<a style="color:inherit;" class="button-link" is="emby-linkbutton" href="'+appRouter.getRouteUrl({Name:p.Name,Type:"Person",ServerId:item.ServerId,Id:p.Id},{context:context})+'">'+dom.htmlEncode(p.Name)+"</a>"}).join(", "),elem=page.querySelector(".directors");elem.innerHTML=1<directors.length?globalize.translate("DirectorsValue",html):globalize.translate("DirectorValue",html),directors.length?elem.classList.remove("hide"):elem.classList.add("hide")}(view,item,void 0),renderTrackSelections(view,instance,item,user,!0),renderChildren(view,item,apiClient),function(view,user,item){if(appHost.supports("sync"))for(var canSync=itemHelper.canSync(user,item),buttons=view.querySelectorAll(".btnSyncDownload"),i=0,length=buttons.length;i<length;i++)buttons[i].setItem(item),canSync?buttons[i].classList.remove("hide"):buttons[i].classList.add("hide")}(view,user,item),function(view,item,user){item.PartCount?connectionManager.getApiClient(item.ServerId).getAdditionalVideoParts(user.Id,item.Id).then(function(result){var section=view.querySelector(".additionalPartsSection");result.Items.length?(section.classList.remove("hide"),cardBuilder.buildCards(result.Items,{parentContainer:section,itemsContainer:section.querySelector(".itemsContainer"),shape:"autooverflow",scalable:!0,showTitle:!0,action:"playallfromhere",centerText:!0,overlayText:!1,showRuntime:!0})):section.classList.add("hide")}):view.querySelector(".additionalPartsSection").classList.add("hide")}(view,item,user),function(view,item,apiClient){var userId,section=view.querySelector(".moreFromSeasonSection");"Episode"===item.Type&&item.SeasonId&&item.SeriesId?(userId=apiClient.getCurrentUserId(),apiClient.getEpisodes(item.SeriesId,{SeasonId:item.SeasonId,UserId:userId,Fields:"PrimaryImageAspectRatio,BasicSyncInfo,CanDelete",EnableTotalRecordCount:!1}).then(function(result){var itemsContainer,card;result.Items.length<2?section.classList.add("hide"):(section.classList.remove("hide"),section.querySelector("h2").innerHTML=globalize.translate("MoreFromValue",item.SeasonName),itemsContainer=section.querySelector(".itemsContainer"),cardBuilder.buildCards(result.Items,{parentContainer:section,itemsContainer:itemsContainer,shape:"auto",scalable:!0,showTitle:!0,overlayText:!1,centerText:!0,includeParentInfoInTitle:!1,allowBottomPadding:!1}),(card=itemsContainer.querySelector('.card[data-id="'+item.Id+'"]'))&&section.querySelector(".emby-scroller").toStart(card.previousSibling||card,!0))})):section.classList.add("hide")}(view,item,apiClient),function(view,item){var section=view.querySelector(".peopleSection"),people=(item.People||[]).filter(function(p){return"Director"!==p.Type});people.length=Math.min(people.length,32),people.length?(section.classList.remove("hide"),require(["peoplecardbuilder"],function(peoplecardbuilder){peoplecardbuilder.buildPeopleCards(people,{parentContainer:section,itemsContainer:section.querySelector(".itemsContainer"),coverImage:!0,serverId:item.ServerId,shape:"portrait"})})):section.classList.add("hide")}(view,item),function(view,item,apiClient){var section=view.querySelector(".extrasSection");itemHelper.supportsExtras(item)?apiClient.getSpecialFeatures(apiClient.getCurrentUserId(),item.Id).then(function(items){items.length?(section.classList.remove("hide"),cardBuilder.buildCards(items,{parentContainer:section,itemsContainer:section.querySelector(".itemsContainer"),shape:"autooverflow",scalable:!0,showTitle:!0,action:"playallfromhere",centerText:!0,overlayText:!1,showRuntime:!0})):section.classList.add("hide")}):section.classList.add("hide")}(view,item,apiClient),function(view,item,apiClient){var query,section=view.querySelector(".moreFromArtistSection");"MusicArtist"===item.Type||"MusicAlbum"===item.Type&&item.AlbumArtists&&item.AlbumArtists.length?(query={IncludeItemTypes:"MusicAlbum",Recursive:!0,ExcludeItemIds:item.Id,SortBy:"ProductionYear,SortName",SortOrder:"Descending",EnableTotalRecordCount:!1,Fields:"PrimaryImageAspectRatio,ProductionYear,CanDelete"},"MusicArtist"===item.Type?query.ContributingArtistIds=item.Id:query.AlbumArtistIds=item.AlbumArtists[0].Id,apiClient.getItems(apiClient.getCurrentUserId(),query).then(function(result){result.Items.length?(section.classList.remove("hide"),"MusicArtist"===item.Type?section.querySelector("h2").innerHTML=globalize.translate("HeaderAppearsOn"):section.querySelector("h2").innerHTML=globalize.translate("MoreFromValue",dom.htmlEncode(item.AlbumArtists[0].Name)),cardBuilder.buildCards(result.Items,{parentContainer:section,itemsContainer:section.querySelector(".itemsContainer"),shape:"auto",scalable:!0,coverImage:"MusicArtist"===item.Type||"MusicAlbum"===item.Type,showTitle:!0,showParentTitle:!1,centerText:!0,overlayText:!1,overlayPlayButton:!0,showYear:!0})):section.classList.add("hide")})):section.classList.add("hide")}(view,item,apiClient),function(view,item){var section=view.querySelector(".scenesSection"),chapters=item.Chapters||[];chapters.length&&!chapters[0].ImageTag&&(chapters=[]),chapters.length?(section.classList.remove("hide"),require(["chaptercardbuilder"],function(chaptercardbuilder){chaptercardbuilder.buildChapterCards(item,chapters,{parentContainer:section,itemsContainer:section.querySelector(".itemsContainer"),width:Math.round(section.offsetWidth/4)})})):section.classList.add("hide")}(view,item),function(page,item,apiClient){var seriesScheduleSection=page.querySelector(".seriesScheduleSection");"Series"===item.Type?apiClient.getLiveTvPrograms({UserId:apiClient.getCurrentUserId(),HasAired:!1,SortBy:"StartDate",EnableTotalRecordCount:!1,ImageTypeLimit:1,EnableImageTypes:"Primary,Thumb,Backdrop",Limit:50,EnableUserData:!1,LibrarySeriesId:item.Id,Fields:"PrimaryImageAspectRatio,ChannelInfo"}).then(function(result){result.Items.length?seriesScheduleSection.classList.remove("hide"):seriesScheduleSection.classList.add("hide");var seriesScheduleList=seriesScheduleSection.querySelector(".itemsContainer");seriesScheduleList.innerHTML=cardBuilder.getCardsHtml({items:result.Items,preferThumb:"auto",shape:"autooverflow",showParentTitle:!1,showTitle:!0,centerText:!0,overlayText:!1,overlayMoreButton:!1,overlayPlayButton:!1,showAirTime:!0,showAirDateTime:!0,lines:3,multiSelect:!1,moreButton:!1,showChannelName:!0}),loading.hide(),imageLoader.lazyChildren(seriesScheduleList)}):seriesScheduleSection.classList.add("hide")}(view,item,apiClient),function(page,item,apiClient,context){var options,section=page.querySelector(".appearsOnListsSection");apiClient.isMinServerVersion("4.3.0.10")&&(itemHelper.supportsAddingToCollection(item)||itemHelper.supportsAddingToPlaylist(item))?(options={fields:"PrimaryImageAspectRatio,UserData,CanDelete",EnableTotalRecordCount:!1,IncludeItemTypes:"Playlist,BoxSet",Recursive:!0,SortBy:"SortName",ListItemIds:item.Id},apiClient.getItems(apiClient.getCurrentUserId(),options).then(function(result){var html,itemsContainer;result.Items.length?(section.classList.remove("hide"),html="",html+=cardBuilder.getCardsHtml({items:result.Items,shape:"autooverflow",centerText:!0,showTitle:!0,context:context,overlayText:!1}),(itemsContainer=section.querySelector(".itemsContainer")).innerHTML=html,imageLoader.lazyChildren(itemsContainer)):section.classList.add("hide")})):section.classList.add("hide")}(view,item,apiClient,void 0),function(view,item,apiClient,context){var options,section=view.querySelector(".similarSection");itemHelper.supportsSimilarItems(item)?(options={Limit:12,UserId:apiClient.getCurrentUserId(),ImageTypeLimit:1,Fields:"PrimaryImageAspectRatio,UserData,CanDelete,ProductionYear",EnableTotalRecordCount:!1},"MusicAlbum"===item.Type&&item.AlbumArtists&&item.AlbumArtists.length&&(options.ExcludeArtistIds=item.AlbumArtists[0].Id),apiClient.getSimilarItems(item.Id,options).then(function(result){result.Items.length?(section.classList.remove("hide"),cardBuilder.buildCards(result.Items,{parentContainer:section,itemsContainer:section.querySelector(".itemsContainer"),shape:"auto",showParentTitle:"MusicAlbum"===item.Type||"Game"===item.Type||"Program"===item.Type,lines:"Game"===item.Type?3:"Program"===item.Type?2:null,centerText:!0,showTitle:!0,context:context,overlayPlayButton:!0,overlayText:!1,showYear:"Movie"===item.Type||"Trailer"===item.Type||"Program"===item.Type||"Game"===item.Type})):section.classList.add("hide")})):section.classList.add("hide")}(view,item,apiClient,void 0),function(page,item,apiClient,context){var options,similarCollapsible=page.querySelector(".similarOnLiveTVCollapsible");similarCollapsible&&(itemHelper.supportsSimilarItemsOnLiveTV(item,apiClient)?(options={userId:apiClient.getCurrentUserId(),limit:12,fields:"PrimaryImageAspectRatio,UserData,CanDelete,ProductionYear",IncludeItemTypes:"Program",EnableTotalRecordCount:!1},apiClient.getSimilarItems(item.Id,options).then(function(result){var html,similarContent;result.Items.length?(similarCollapsible.classList.remove("hide"),html="",html+=cardBuilder.getCardsHtml({items:result.Items,shape:"autooverflow",showTitle:!0,showParentTitle:!0,centerText:!0,context:context,showDetailsMenu:!0,overlayPlayButton:!0,overlayText:!1,lines:2,showYear:!0}),(similarContent=similarCollapsible.querySelector(".itemsContainer")).innerHTML=html,imageLoader.lazyChildren(similarContent)):similarCollapsible.classList.add("hide")})):similarCollapsible.classList.add("hide"))}(view,item,apiClient,void 0),function(view,item,user,apiClient){if("SeriesTimer"===item.Type){if(!user.Policy.EnableLiveTvManagement)return view.querySelector(".seriesTimerScheduleSection").classList.add("hide"),view.querySelector(".btnCancelSeriesTimer").classList.add("hide");require(["seriesRecordingEditor"],function(seriesRecordingEditor){seriesRecordingEditor.embed(item,apiClient.serverId(),{context:view.querySelector(".seriesRecordingEditor")})}),view.querySelector(".seriesTimerScheduleSection").classList.remove("hide"),view.querySelector(".btnCancelSeriesTimer").classList.remove("hide"),renderSeriesTimerSchedule(view,item.Id,apiClient)}}(view,item,user,apiClient),function(page,item,user){"Recording"===item.Type&&user.Policy.EnableLiveTvManagement&&item.TimerId&&"InProgress"===item.Status?hideAll(page,"btnCancelTimer",!0):hideAll(page,"btnCancelTimer")}(view,item,user),function(page,item){var linksElem=page.querySelector(".linksSection"),links=[];if(item.ExternalUrls&&appHost.supports("externallinks")&&!layoutManager.tv)for(var i=0,length=item.ExternalUrls.length;i<length;i++){var url=item.ExternalUrls[i];links.push('<a style="color:inherit;" is="emby-linkbutton" class="raised item-tag-button nobackdropfilter" href="'+url.Url+'" target="_blank"><i class="md-icon button-icon button-icon-left">link</i>'+dom.htmlEncode(url.Name)+"</a>")}linksElem.querySelector(".itemLinks").innerHTML=links.join(""),links.length?linksElem.classList.remove("hide"):linksElem.classList.add("hide")}(view,item),enableTrackList(item)||focusMainSection.call(mainSection)),renderNextUp(view,item),loading.hide()})}function onFullReloadNeeded(){reloadItem(this,!0)}function addClass(elems,className){for(var i=0,length=elems.length;i<length;i++)elems[i].classList.add(className)}function setScopedFocus(view,query,enabled,type){var elem="string"==typeof query?view.querySelector(query):query;enabled?(elem.classList.add("focusable"),elem.setAttribute("data-focusabletype",type||"autofocus")):(elem.classList.remove("focusable"),elem.removeAttribute("data-focusabletype"))}function updateTrackSelectionsFocusState(view){var elem=view.querySelector(".trackSelections");setScopedFocus(view,".trackSelections",elem.querySelector("select:not([disabled]):not(.noSelections)"))}function onDetailMainContainerFocus(e){var target=e.target;target.classList.contains("btnReadMore")||dom.parentWithClass(target,"seriesRecordingEditor")||this.view.scrollToPosition(0,!1)}function ItemPage(view,params){BaseView.apply(this,arguments),this.view=view,this.params=params,this.playerChangeFn=function(){renderTrackSelectionsWithoutUser(this.view,this,this.currentItem)}.bind(this),this.onInputCommandFn=onInputCommand.bind(this),layoutManager.tv?(view.querySelector(".detailLogo").classList.add("detailLogo-tv"),view.querySelector(".detailLogoContainer").classList.add("detailLogoContainer-tv"),addClass(view.querySelectorAll(".reduce-font-size-tv"),"reduce-font-size")):addClass(view.querySelectorAll(".mainDetailButtons"),"detailButtons-largefont"),function(view,query,enabled,type){for(var elems=view.querySelectorAll(query),i=0,length=elems.length;i<length;i++)setScopedFocus(view,elems[i],enabled,type)}(view,".focusable",!0,"nearest"),view.querySelector(".trackSelections").addEventListener("submit",onTrackSelectionsSubmit),view.querySelector(".trackList").refreshItems=onFullReloadNeeded.bind(this),bindAll(view,".btnPlay","click",onPlayClick.bind(this)),bindAll(view,".btnResume","click",onPlayClick.bind(this)),bindAll(view,".btnQueue","click",onQueueClick.bind(this)),bindAll(view,".btnInstantMix","click",function(){var currentItem=this.currentItem;playbackManager.instantMix(currentItem)}.bind(this)),bindAll(view,".btnShuffle","click",function(){var currentItem=this.currentItem;playbackManager.shuffle(currentItem)}.bind(this)),bindAll(view,".btnPlayTrailer","click",function(){var currentItem=this.currentItem;playbackManager.playTrailers(currentItem)}.bind(this)),bindAll(view,".btnCancelSeriesTimer","click",function(){var currentItem=this.currentItem;require(["recordingHelper"],function(recordingHelper){recordingHelper.cancelSeriesTimerWithConfirmation(currentItem.Id,currentItem.ServerId).then(function(){appRouter.showLiveTV(currentItem.ServerId)})})}.bind(this)),bindAll(view,".btnCancelTimer","click",function(){var instance=this;require(["recordingHelper"],function(recordingHelper){recordingHelper.cancelTimer(connectionManager.getApiClient(instance.currentItem.ServerId),instance.currentItem.TimerId).then(function(){reloadItem(instance,!0)})})}.bind(this)),bindAll(view,".btnDeleteItem","click",function(){var currentItem=this.currentItem;require(["deleteHelper"],function(deleteHelper){deleteHelper.deleteItem({item:currentItem,navigate:"back"})})}.bind(this)),bindAll(view,".btnSyncDownload","download",onDownloadChange.bind(this)),bindAll(view,".btnSyncDownload","download-cancel",onDownloadChange.bind(this)),bindAll(view,".btnMoreCommands","click",function(e){var button=e.currentTarget,instance=this,params=this.params,apiClient=connectionManager.getApiClient(params.serverId),currentItem=this.currentItem,view=this.view;apiClient.getCurrentUser().then(function(user){itemContextMenu.show(getContextMenuOptions(view,currentItem,user,button)).then(function(result){result.deleted?appRouter.goHome():result.updated&&reloadItem(instance,!0)})})}.bind(this)),bindAll(view,".btnManageSeriesRecording","click",function(e){var item=this.currentItem;item.SeriesTimerId&&appRouter.showItem({Type:"SeriesTimer",Id:item.SeriesTimerId,ServerId:item.ServerId})}.bind(this)),view.querySelector(".detailMainContainer").addEventListener("focus",onDetailMainContainerFocus.bind(this),!0),view.querySelector(".item-side-buttons").addEventListener("focus",onDetailMainContainerFocus.bind(this),!0),bindAll(view,".btnSplitVersions","click",onSplitVersionsClick.bind(this)),bindAll(view,".btnReadMore","click",onReadMoreClick);var instance=this;view.querySelector(".selectSource").addEventListener("change",function(){renderVideoSelections(view,instance._currentPlaybackMediaSources),renderAudioSelections(view,instance._currentPlaybackMediaSources),renderSubtitleSelections(view,instance._currentPlaybackMediaSources),updateTrackSelectionsFocusState(view)}),view.addEventListener("viewbeforeshow",function(){startDataLoad(this)}.bind(this)),view.addEventListener("viewshow",function(e){document.querySelector(".backgroundContainer").classList.add("itemBackgroundContainer"),document.querySelector(".backdropContainer").classList.add("backdropContainer-item");var view=this.view,onInputCommandFn=this.onInputCommandFn;onInputCommandFn&&inputManager.on(view,onInputCommandFn);var currentItem,isRestored=e.detail.isRestored;reloadItem(this,!isRestored,!1),isRestored&&(renderTrackSelectionsWithoutUser(view,this,currentItem=this.currentItem,!0),setTrailerButtonVisibility(view,currentItem));var onPlayerChangeFn=this.playerChangeFn;onPlayerChangeFn&&events.on(playbackManager,"playerchange",onPlayerChangeFn)}.bind(this)),view.addEventListener("viewbeforehide",function(){var view=this.view,onInputCommandFn=this.onInputCommandFn;onInputCommandFn&&inputManager.off(view,onInputCommandFn);var onPlayerChangeFn=this.playerChangeFn;onPlayerChangeFn&&events.off(playbackManager,"playerchange",onPlayerChangeFn);var backgroundContainer=document.querySelector(".backgroundContainer");backgroundContainer.classList.remove("itemBackgroundContainer"),backgroundContainer.classList.remove("itemBackgroundContainer-graphic"),document.querySelector(".backdropContainer").classList.remove("backdropContainer-item")}.bind(this));var onUserDataChangedFn=this.onUserDataChangedFn=function(e,apiClient,userData){var currentItem=this.currentItem,view=this.view;currentItem&&currentItem.Id===userData.ItemId&&"Video"===currentItem.MediaType&&(currentItem.UserData=userData,reloadPlayButtons(view,currentItem,!0))}.bind(this);events.on(serverNotifications,"UserDataChanged",onUserDataChangedFn)}return Object.assign(ItemPage.prototype,BaseView.prototype),ItemPage.prototype.destroy=function(){BaseView.prototype.destroy.apply(this,arguments);var onUserDataChangedFn=this.onUserDataChangedFn;onUserDataChangedFn&&events.off(serverNotifications,"UserDataChanged",onUserDataChangedFn),this.onUserDataChangedFn=null,this.currentItem=null,this._currentPlaybackMediaSources=null,this.currentRecordingFields&&(this.currentRecordingFields.destroy(),this.currentRecordingFields=null),this.view=null,this.params=null,this.dataPromises=null,this.playerChangeFn=null,this.onInputCommandFn=null},ItemPage});