define(["itemShortcuts","inputManager","connectionManager","playbackManager","imageLoader","layoutManager","browser","dom","loading","focusManager","serverNotifications","events","cardBuilder","virtual-scroller"],function(itemShortcuts,inputManager,connectionManager,playbackManager,imageLoader,layoutManager,browser,dom,loading,focusManager,serverNotifications,events,cardBuilder){"use strict";var MultiSelect,touchTarget;function onClick(e){e.target;var multiSelect=this.multiSelect;multiSelect&&!1===multiSelect.onContainerClick.call(this,e)||itemShortcuts.onClick.call(this,e)}function disableEvent(e){return e.preventDefault(),e.stopPropagation(),!1}function onContextMenu(e){var target=e.target,card=itemShortcuts.getItemElementFromChildNode(target,!0);if(card)return this.classList.contains("multi-select-active")||inputManager.trigger("menu",{sourceElement:card}),e.preventDefault(),e.stopPropagation(),!1}function _enableMultiSelect(enabled){var self,current=this.multiSelect;enabled?current||(self=this,require(["multiSelect"],function(multiSelect){MultiSelect=multiSelect,self.multiSelect=new MultiSelect({container:self,bindOnClick:!1})})):current&&(this.multiSelect=null)}function _showMultiSelect(childElement,selected){var card=itemShortcuts.getItemElementFromChildNode(childElement,!0);this.multiSelect.showSelections(card,selected)}function onContainerTouchStart(e){var element=e.target;element&&element.classList.contains("listViewDragHandle")&&e.preventDefault()}function _enableDragReordering(enabled){var self,current=this.sortable;enabled?current||(self=this,require(["sortable"],function(Sortable){self.sortable=new Sortable(self,{draggable:".listItem",handle:".listViewDragHandle",onEnd:function(evt){return function(evt,itemsContainer){var serverId,apiClient,oldIndex,el=evt.item,newIndex=evt.newIndex,itemId=el.getAttribute("data-playlistitemid"),playlistId=el.getAttribute("data-playlistid");playlistId?(serverId=el.getAttribute("data-serverid"),apiClient=connectionManager.getApiClient(serverId),loading.show(),apiClient.ajax({url:apiClient.getUrl("Playlists/"+playlistId+"/Items/"+itemId+"/Move/"+newIndex),type:"POST"}).then(function(){loading.hide()},function(){loading.hide(),itemsContainer.refreshItems()})):(oldIndex=evt.oldIndex,el.dispatchEvent(new CustomEvent("itemdrop",{detail:{oldIndex:oldIndex,newIndex:newIndex,playlistItemId:itemId},bubbles:!0,cancelable:!1})))}(evt,self)}}),(browser.iOS||browser.osx)&&self.sortable.el.addEventListener("touchstart",onContainerTouchStart)})):current&&(current.destroy(),this.sortable=null)}function onUserDataChanged(e,apiClient,userData){cardBuilder.onUserDataChanged(userData,this);var eventsToMonitor=getEventsToMonitor(this);-1===eventsToMonitor.indexOf("markfavorite")&&-1===eventsToMonitor.indexOf("markplayed")||this.notifyRefreshNeeded()}function getEventsToMonitor(itemsContainer){var monitor=itemsContainer.getAttribute("data-monitor");return monitor?monitor.split(","):[]}function onTimerCreated(e,apiClient,data){var programId,newTimerId;-1===getEventsToMonitor(this).indexOf("timers")?(programId=data.ProgramId,newTimerId=data.Id,cardBuilder.onTimerCreated(programId,newTimerId,this)):this.notifyRefreshNeeded()}function onSeriesTimerCreated(e,apiClient,data){-1===getEventsToMonitor(this).indexOf("seriestimers")||this.notifyRefreshNeeded()}function onTimerCancelled(e,apiClient,data){var id;-1===getEventsToMonitor(this).indexOf("timers")?(id=data.Id,cardBuilder.onTimerCancelled(id,this)):this.notifyRefreshNeeded()}function onSeriesTimerCancelled(e,apiClient,data){var id;-1===getEventsToMonitor(this).indexOf("seriestimers")?(id=data.Id,cardBuilder.onSeriesTimerCancelled(id,this)):this.notifyRefreshNeeded()}function onLibraryChanged(e,apiClient,data){var eventsToMonitor=getEventsToMonitor(this);if(-1===eventsToMonitor.indexOf("seriestimers")&&-1===eventsToMonitor.indexOf("timers")){var itemsAdded=data.ItemsAdded||[],itemsRemoved=data.ItemsRemoved||[];if(itemsAdded.length||itemsRemoved.length){var parentId=this.getAttribute("data-parentid");if(parentId){var foldersAddedTo=data.FoldersAddedTo||[],foldersRemovedFrom=data.FoldersRemovedFrom||[],collectionFolders=data.CollectionFolders||[];if(-1===foldersAddedTo.indexOf(parentId)&&-1===foldersRemovedFrom.indexOf(parentId)&&-1===collectionFolders.indexOf(parentId))return}this.notifyRefreshNeeded()}}}function onPlaybackStopped(e,stopInfo){var state=stopInfo.state,eventsToMonitor=getEventsToMonitor(this);if(state.NowPlayingItem&&"Video"===state.NowPlayingItem.MediaType){if(-1!==eventsToMonitor.indexOf("videoplayback"))return void this.notifyRefreshNeeded(!0)}else if(state.NowPlayingItem&&"Audio"===state.NowPlayingItem.MediaType&&-1!==eventsToMonitor.indexOf("audioplayback"))return void this.notifyRefreshNeeded(!0)}function addNotificationEvent(instance,name,handler,owner){var localHandler=handler.bind(instance);owner=owner||serverNotifications,events.on(owner,name,localHandler),instance["event_"+name]=localHandler}function removeNotificationEvent(instance,name,owner){var handler=instance["event_"+name];handler&&(owner=owner||serverNotifications,events.off(owner,name,handler),instance["event_"+name]=null)}function onInit(){this.hasInit||(this.hasInit=!0,this.classList.add("itemsContainer"))}function getTouches(e){return e.changedTouches||e.targetTouches||e.touches}function clearTouchStartTimeout(elem){elem.touchStartTimeout&&(clearTimeout(elem.touchStartTimeout),elem.touchStartTimeout=null,elem.touchStartTimeoutTime=null)}function clearTouchTarget(container){touchTarget&&(touchTarget=null,dom.removeEventListener(container,"touchmove",onTouchMove,{passive:!0}))}function onTouchStart(e){var element,card,touch=getTouches(e)[0];clearTouchTarget(this),this.touchStartX=0,this.touchStartY=0,touch&&(this.touchStartX=touch.clientX,this.touchStartY=touch.clientY,!(element=touch.target)||(card=dom.parentWithClass(element,["card","listItem"]))&&(clearTouchStartTimeout(this),dom.addEventListener(this,"touchmove",onTouchMove,{passive:!0}),touchTarget=card,this.touchStartTimeout=setTimeout(onTouchStartTimerFired,550),this.touchStartTimeoutTime=Date.now()))}function onTouchMove(e){var touch,touchEndX,touchEndY,deltaX,deltaY;touchTarget&&(deltaY=(touch=getTouches(e)[0])?(touchEndX=touch.clientX||0,touchEndY=touch.clientY||0,deltaX=Math.abs(touchEndX-(this.touchStartX||0)),Math.abs(touchEndY-(this.touchStartY||0))):deltaX=100,(5<=deltaX||5<=deltaY)&&(clearTouchStartTimeout(this),clearTouchTarget(this)))}function onTouchEnd(e){var time;!getTouches(e)[0]||(time=this.touchStartTimeoutTime)&&500<=(time=Date.now()-time)&&e.preventDefault(),clearTouchStartTimeout(this),clearTouchTarget(this)}var emptyFn=function(){};function onTouchStartTimerFired(){var container,card=touchTarget;card&&(container=dom.parentWithClass(card,"itemsContainer"),onContextMenu.call(container,{target:card,preventDefault:emptyFn,stopPropagation:emptyFn}))}function _connectedCallback(){var element;this.addEventListener("click",onClick),"false"!==this.getAttribute("data-contextmenu")&&((element=this).addEventListener("contextmenu",onContextMenu,!0),(browser.iOS||browser.osx)&&(dom.addEventListener(element,"touchstart",onTouchStart,{passive:!0}),dom.addEventListener(element,"touchend",onTouchEnd,{}),dom.addEventListener(element,"touchcancel",onTouchEnd,{}))),layoutManager.tv?this.classList.add("itemsContainer-tv"):"false"!==this.getAttribute("data-multiselect")&&this.enableMultiSelect(!0),itemShortcuts.on(this,{click:!1}),addNotificationEvent(this,"UserDataChanged",onUserDataChanged),addNotificationEvent(this,"TimerCreated",onTimerCreated),addNotificationEvent(this,"SeriesTimerCreated",onSeriesTimerCreated),addNotificationEvent(this,"TimerCancelled",onTimerCancelled),addNotificationEvent(this,"SeriesTimerCancelled",onSeriesTimerCancelled),addNotificationEvent(this,"LibraryChanged",onLibraryChanged),addNotificationEvent(this,"playbackstop",onPlaybackStopped,playbackManager),"true"===this.getAttribute("data-dragreorder")&&this.enableDragReordering(!0),this.dispatchEvent(new CustomEvent("upgraded",{cancelable:!1}))}function _disconnectedCallback(){clearRefreshInterval(this),abortRequests(this),this.enableMultiSelect(!1),this.enableDragReordering(!1),this.removeEventListener("click",onClick),this.removeEventListener("contextmenu",onContextMenu),this.removeEventListener("contextmenu",disableEvent),itemShortcuts.off(this,{click:!1}),removeNotificationEvent(this,"UserDataChanged"),removeNotificationEvent(this,"TimerCreated"),removeNotificationEvent(this,"SeriesTimerCreated"),removeNotificationEvent(this,"TimerCancelled"),removeNotificationEvent(this,"SeriesTimerCancelled"),removeNotificationEvent(this,"LibraryChanged"),removeNotificationEvent(this,"playbackstop",playbackManager),this.fetchData=null,this.getItemsHtml=null,this.parentContainer=null,this.virtualScroller=null,this.currentListOptions=null,this.itemParts=null,this.items=null}function _pause(){clearRefreshInterval(this,!0),this.paused=!0;var virtualScroller=this.virtualScroller;virtualScroller&&virtualScroller.pause()}function _resume(options){this.paused=!1;var remainingMs,refreshIntervalEndTime=this.refreshIntervalEndTime;refreshIntervalEndTime&&(0<(remainingMs=refreshIntervalEndTime-Date.now())&&!this.needsRefresh?resetRefreshInterval(this,remainingMs):(this.needsRefresh=!0,this.refreshIntervalEndTime=null));var virtualScroller=this.virtualScroller;return virtualScroller&&virtualScroller.resume(),this.needsRefresh||options&&options.refresh?this.refreshItems():Promise.resolve()}function abortRequests(instance){var currentAbortController=instance.currentAbortController;currentAbortController&&(currentAbortController.abort(),instance.currentAbortController=null)}function onGetItemsFailed(){}function _refreshItems(){if(!this.fetchData)return Promise.resolve();if(this.paused)return this.needsRefresh=!0,Promise.resolve();this.needsRefresh=!1,abortRequests(this);var abortController=new AbortController;return this.currentAbortController=abortController,this.fetchData({},abortController.signal).then(function(result){var items=result.Items||result,parentContainer=this.parentContainer;parentContainer&&(items.length?parentContainer.classList.remove("hide"):parentContainer.classList.add("hide"));var focusId,focusIndex,hasActiveElement,activeElement=document.activeElement;{var focusIndexElement;this.contains(activeElement)&&(hasActiveElement=!0,focusId=activeElement.getAttribute("data-id"),focusIndexElement=itemShortcuts.getItemElementFromChildNode(activeElement,!0),focusIndex=focusIndexElement?focusIndexElement.getAttribute("data-index"):null)}var delay=0,listOptions=this.getListOptions?this.getListOptions(items):null,minItemsForVirtualRendering=this.onUpdateElement?0:31;{var virtualScroller,listItemOptions,itemParts;(items.length>=minItemsForVirtualRendering||items.length<(result.TotalRecordCount||0))&&this.hasAttribute("data-virtualscrolllayout")&&!browser.msie?(listOptions&&(listOptions.options.lazy=2,listOptions.renderer.setListOptions(items,listOptions.options)),(virtualScroller=this.virtualScroller)&&listOptions.enableScrollReuse&&virtualScroller.templateInnerHTML===listOptions.options.templateInnerHTML||(listItemOptions=(this.currentListOptions=listOptions).options,this.innerHTML='<div is="virtual-scroller" class="flex-grow virtualScroller" layout="'+listOptions.virtualScrollLayout+'"></div>',(virtualScroller=this.querySelector(".virtualScroller")).virtualChunkSize=this.virtualChunkSize||50,virtualScroller.templateInnerHTML=listItemOptions.templateInnerHTML,virtualScroller.templateHTML="<"+listItemOptions.tagName+' class="virtualScrollItem '+listItemOptions.className+'">'+listItemOptions.templateInnerHTML+"</"+listItemOptions.tagName+">",virtualScroller.getItems=this.fetchData.bind(this),(this.virtualScroller=virtualScroller).updateElement=function(child,item,index){for(var listOptions=this.currentListOptions,listItemOptions=listOptions.options,renderer=listOptions.renderer,itemParts=this.itemParts[index]||(this.itemParts[index]=renderer.getItemParts(item,index,listItemOptions)),attributes=itemParts.attributes,i=0,length=attributes.length;i<length;i++){var att=attributes[i];child.setAttribute(att.name,att.value)}child.innerHTML=itemParts.html;var multiSelect=MultiSelect;{var chkCardSelect;multiSelect&&item.Id&&multiSelect.isSelected(item)&&((chkCardSelect=child.querySelector(".chkCardSelect"))&&(chkCardSelect.checked=!0,child.querySelector(".cardBox").classList.add("item-multiselected")))}var onUpdateElement=this.onUpdateElement;this.onUpdateElement&&onUpdateElement(child,item,index)}.bind(this),virtualScroller.onRecycleElement=this.onRecycleElement),this.items=null,(itemParts=[]).length=result.TotalRecordCount||items.length,this.itemParts=itemParts,delay=virtualScroller.setItemSource?(virtualScroller.setItemSource(items,result.TotalRecordCount),50):(dom.addEventListener(virtualScroller,"upgraded",function(e){var items=this.Items||this;e.currentTarget.setItemSource(items,this.TotalRecordCount)}.bind(result),{once:!0}),100)):(this.itemParts=null,this.currentListOptions=null,this.innerHTML=listOptions?listOptions.renderer.getItemsHtml(items,listOptions.options):this.getItemsHtml(items),this.virtualScroller=null,this.items=items,imageLoader.lazyChildren(this))}return(delay?function(delay){return new Promise(function(resolve,reject){setTimeout(resolve,delay)})}(delay):Promise.resolve()).then(function(){hasActiveElement&&function(itemsContainer,focusId,focusIndex){var newElement;if(focusId&&(newElement=itemsContainer.querySelector('[data-id="'+focusId+'"]')))try{return focusManager.focus(newElement)}catch(err){}if(null!=focusIndex)return _scrollToIndex.call(itemsContainer,parseInt(focusIndex),!0);layoutManager.tv&&focusManager.autoFocus(itemsContainer)}(this,focusId,focusIndex),resetRefreshInterval(this),this.afterRefresh&&this.afterRefresh(result)}.bind(this))}.bind(this),onGetItemsFailed)}function _notifyRefreshNeeded(isInForeground){var timeout;this.paused?this.needsRefresh=!0:((timeout=this.refreshTimeout)&&clearTimeout(timeout),!0===isInForeground?this.refreshItems():this.refreshTimeout=setTimeout(this.refreshItems.bind(this),1e4))}function clearRefreshInterval(itemsContainer,isPausing){itemsContainer.refreshInterval&&(clearInterval(itemsContainer.refreshInterval),itemsContainer.refreshInterval=null,isPausing||(itemsContainer.refreshIntervalEndTime=null))}function resetRefreshInterval(itemsContainer,intervalMs){clearRefreshInterval(itemsContainer),(intervalMs=intervalMs||parseInt(itemsContainer.getAttribute("data-refreshinterval")||"0"))&&(itemsContainer.refreshInterval=setInterval(itemsContainer.notifyRefreshNeeded.bind(itemsContainer),intervalMs),itemsContainer.refreshIntervalEndTime=Date.now()+intervalMs)}function _scrollToIndex(index,focus){var virtualScroller=this.virtualScroller;if(virtualScroller)return virtualScroller.scrollToIndex(index,focus);var item,focusableElement,items=this.querySelectorAll(".card,.listItem");!items.length||(item=items[index]||items[items.length-1])&&(focusableElement=item.querySelector(".cardContent-button")||item,focusManager.focus(focusableElement))}function _getItem(index){var scroller=this.virtualScroller;if(scroller)return scroller.getItem(index);var items=this.items;return items?items[index]:null}function _pageUp(activeElement){var currentIndex,newIndex,virtualScroller=this.virtualScroller;(virtualScroller?virtualScroller._itemSource:this.items)&&(activeElement=itemShortcuts.getItemElementFromChildNode(activeElement,!0)||activeElement,newIndex=-1===(currentIndex=parseInt(activeElement.getAttribute("data-index")||"-1"))?0:Math.max(0,currentIndex-12),console.log("pageUp: "+newIndex),_scrollToIndex.call(this,newIndex,!0))}function _pageDown(activeElement){var currentIndex,newIndex,virtualScroller=this.virtualScroller,items=virtualScroller?virtualScroller._itemSource:this.items;items&&(activeElement=itemShortcuts.getItemElementFromChildNode(activeElement,!0)||activeElement,newIndex=-1===(currentIndex=parseInt(activeElement.getAttribute("data-index")||"-1"))?0:Math.min(items.length-1,currentIndex+12),console.log("pageDown: "+newIndex),_scrollToIndex.call(this,newIndex,!0))}function _focusLast(){var virtualScroller=this.virtualScroller,items=virtualScroller?virtualScroller._itemSource:this.items;items&&_scrollToIndex.call(this,items.length-1,!0)}if(window.customElements){var EmbyItemsContainer=function(_HTMLDivElement){babelHelpers.inherits(EmbyItemsContainer,_HTMLDivElement);var _super=_createSuper(EmbyItemsContainer);function EmbyItemsContainer(){var _this;babelHelpers.classCallCheck(this,EmbyItemsContainer);var self=_this=_super.call(this);return onInit.call(self),babelHelpers.possibleConstructorReturn(_this,self)}return babelHelpers.createClass(EmbyItemsContainer,[{key:"connectedCallback",value:function(){onInit.call(this),_connectedCallback.call(this)}},{key:"disconnectedCallback",value:function(){_disconnectedCallback.call(this)}},{key:"pause",value:function(){return _pause.apply(this,arguments)}},{key:"resume",value:function(){return _resume.apply(this,arguments)}},{key:"getItem",value:function(){return _getItem.apply(this,arguments)}},{key:"refreshItems",value:function(){return _refreshItems.apply(this,arguments)}},{key:"notifyRefreshNeeded",value:function(){_notifyRefreshNeeded.apply(this,arguments)}},{key:"enableDragReordering",value:function(){_enableDragReordering.apply(this,arguments)}},{key:"showMultiSelect",value:function(){_showMultiSelect.apply(this,arguments)}},{key:"enableMultiSelect",value:function(){_enableMultiSelect.apply(this,arguments)}},{key:"scrollToIndex",value:function(){_scrollToIndex.apply(this,arguments)}},{key:"pageUp",value:function(){return _pageUp.apply(this,arguments)}},{key:"pageDown",value:function(){return _pageDown.apply(this,arguments)}},{key:"focusLast",value:function(){return _focusLast.apply(this,arguments)}}]),EmbyItemsContainer}(babelHelpers.wrapNativeSuper(HTMLDivElement));return customElements.define("emby-itemscontainer",EmbyItemsContainer,{extends:"div"}),EmbyItemsContainer}if(document.registerElement){var ItemsContainerProtoType=Object.create(HTMLDivElement.prototype);return ItemsContainerProtoType.createdCallback=onInit,ItemsContainerProtoType.attachedCallback=_connectedCallback,ItemsContainerProtoType.detachedCallback=_disconnectedCallback,ItemsContainerProtoType.pause=_pause,ItemsContainerProtoType.resume=_resume,ItemsContainerProtoType.refreshItems=_refreshItems,ItemsContainerProtoType.notifyRefreshNeeded=_notifyRefreshNeeded,ItemsContainerProtoType.enableDragReordering=_enableDragReordering,ItemsContainerProtoType.showMultiSelect=_showMultiSelect,ItemsContainerProtoType.enableMultiSelect=_enableMultiSelect,ItemsContainerProtoType.scrollToIndex=_scrollToIndex,ItemsContainerProtoType.getItem=_getItem,ItemsContainerProtoType.pageUp=_pageUp,ItemsContainerProtoType.pageDown=_pageDown,ItemsContainerProtoType.focusLast=_focusLast,document.registerElement("emby-itemscontainer",{prototype:ItemsContainerProtoType,extends:"div"}),ItemsContainerProtoType}});