define(["apphost","htmlMediaHelper","playbackManager"],function(appHost,htmlMediaHelper,playbackManager){"use strict";function BaseHtmlPlayer(){this.type="mediaplayer"}function onShakaError(event){var error=event.detail||event;console.log("Error code",error.code,"object",error)}function setCurrentTimeIfNeeded(element,seconds,allowance){Math.abs((element.currentTime||0)-seconds)>=allowance&&(element.currentTime=seconds)}function onMediaManagerStop(event){var mediaManager=window.mediaManager;playbackManager.stop(),mediaManager.defaultOnStop(event)}return BaseHtmlPlayer.prototype.canPlayMediaType=function(mediaType){return(mediaType||"").toLowerCase()===this.mediaType},BaseHtmlPlayer.prototype.currentSrc=function(){return this._currentSrc},BaseHtmlPlayer.prototype.getDeviceProfile=function(item,options){return htmlMediaHelper.getDeviceProfile(this,appHost,item,options)},BaseHtmlPlayer.prototype.currentTime=function(val){var mediaElement=this._mediaElement;if(mediaElement){if(null!=val)return void(mediaElement.currentTime=val/1e3);var currentTime=this._currentTime;return currentTime?1e3*currentTime:1e3*(mediaElement.currentTime||0)}},BaseHtmlPlayer.prototype.duration=function(val){var mediaElement=this._mediaElement;if(mediaElement){var duration=mediaElement.duration;if(htmlMediaHelper.isValidDuration(duration))return 1e3*duration}return null},BaseHtmlPlayer.prototype.getBufferedRanges=function(){var mediaElement=this._mediaElement;return mediaElement?htmlMediaHelper.getBufferedRanges(this,mediaElement):[]},BaseHtmlPlayer.prototype.pause=function(){var mediaElement=this._mediaElement;mediaElement&&mediaElement.pause()},BaseHtmlPlayer.prototype.resume=function(){var mediaElement=this._mediaElement;mediaElement&&mediaElement.play()},BaseHtmlPlayer.prototype.unpause=function(){var mediaElement=this._mediaElement;mediaElement&&mediaElement.play()},BaseHtmlPlayer.prototype.paused=function(){var mediaElement=this._mediaElement;return!!mediaElement&&mediaElement.paused},BaseHtmlPlayer.prototype.setVolume=function(val){var mediaElement=this._mediaElement;mediaElement&&(mediaElement.volume=val/100)},BaseHtmlPlayer.prototype.getVolume=function(){var mediaElement=this._mediaElement;if(mediaElement)return Math.min(Math.round(100*mediaElement.volume),100)},BaseHtmlPlayer.prototype.setPlaybackRate=function(val){var mediaElement=this._mediaElement;mediaElement&&(mediaElement.playbackRate=val)},BaseHtmlPlayer.prototype.getPlaybackRate=function(){var mediaElement=this._mediaElement;if(mediaElement)return mediaElement.playbackRate},BaseHtmlPlayer.prototype.volumeUp=function(){this.setVolume(Math.min(this.getVolume()+2,100))},BaseHtmlPlayer.prototype.volumeDown=function(){this.setVolume(Math.max(this.getVolume()-2,0))},BaseHtmlPlayer.prototype.setMute=function(mute){var mediaElement=this._mediaElement;mediaElement&&(mediaElement.muted=mute)},BaseHtmlPlayer.prototype.isMuted=function(){var mediaElement=this._mediaElement;return!!mediaElement&&mediaElement.muted},BaseHtmlPlayer.prototype.seekable=function(){var mediaElement=this._mediaElement;if(mediaElement){var seekable=mediaElement.seekable;if(seekable&&seekable.length){var start=seekable.start(0),end=seekable.end(0);return htmlMediaHelper.isValidDuration(start)||(start=0),htmlMediaHelper.isValidDuration(end)||(end=0),0<end-start}return!1}},BaseHtmlPlayer.prototype.setSrcWithShakaPlayer=function(elem,options,url){var instance=this;return require(["shaka"]).then(function(responses){var player=new responses[0].Player(elem);return player.configure({abr:{enabled:!1}}),player.addEventListener("error",onShakaError),instance._shakaPlayer=player,instance._currentSrc=url,player.load(url)})},BaseHtmlPlayer.prototype.setCurrentSrcChromecast=function(elem,options,url,hasHlsTextTracks,tracksHtml){var mediaManager=window.mediaManager;elem.autoplay=!0;var lrd=new cast.receiver.MediaManager.LoadRequestData;lrd.currentTime=(options.playerStartPositionTicks||0)/1e7,lrd.autoplay=!0,lrd.media=new cast.receiver.media.MediaInformation,lrd.media.contentId=url,lrd.media.contentType=options.mimeType,lrd.media.streamType=cast.receiver.media.StreamType.BUFFERED,lrd.media.customData={options:options,hasHlsTextTracks:hasHlsTextTracks,tracksHtml:tracksHtml},console.log("loading media url into mediaManager");try{return mediaManager.load(lrd),this._currentSrc=url,Promise.resolve()}catch(err){return console.log("mediaManager error: "+err),Promise.reject()}},BaseHtmlPlayer.prototype.setSrcWithFlvJs=function(elem,options,url){var instance=this;return new Promise(function(resolve,reject){require(["flvjs"],function(flvjs){var flvPlayer=flvjs.createPlayer({type:"flv",url:url},{seekType:"range",lazyLoad:!1,rangeLoadZeroStart:!0});flvPlayer.attachMediaElement(elem),flvPlayer.load(),flvPlayer.play().then(resolve,reject),instance._flvPlayer=flvPlayer,instance._currentSrc=url})})},BaseHtmlPlayer.prototype.setSrcWithHlsJs=function(elem,options,url,onError){var instance=this;return new Promise(function(resolve,reject){var callback;callback=function(){var hls=new Hls({manifestLoadingTimeOut:2e4,debug:!1,testBandwidth:!1,emeEnabled:!1});hls.loadSource(url),hls.attachMedia(elem),htmlMediaHelper.bindEventsToHlsPlayer(instance,hls,elem,onError,resolve,reject),instance._hlsPlayer=hls,instance._currentSrc=url},require(["hlsjs"],function(hls){window.Hls=hls,callback()})})},BaseHtmlPlayer.prototype.seekOnPlaybackStart=function(element,ticks){var seconds=(ticks||0)/1e7;seconds&&(setCurrentTimeIfNeeded(element,seconds,5),5<=Math.abs((element.currentTime||0)-seconds)&&function(element,seconds,allowance){setTimeout(function(){setCurrentTimeIfNeeded(element,seconds,allowance)},2500)}(element,seconds,10))},BaseHtmlPlayer.prototype.bindMediaManagerEvents=function(){var mediaManager=window.mediaManager;mediaManager.defaultOnLoad||(mediaManager.defaultOnLoad=mediaManager.onLoad.bind(mediaManager),mediaManager.onLoad=function(event){var data=event.data,media=data.media,customData=media.customData,val=media.contentId,options=customData.options,elem=this._mediaElement;return this.loadIntoPlayer(elem,options,val,media,data,customData)}.bind(this)),mediaManager.defaultOnError||(mediaManager.defaultOnError=mediaManager.onError.bind(mediaManager),mediaManager.onError=function(event){console.log("media manager onError: "+event),setTimeout(function(){htmlMediaHelper.onErrorInternal(this,"mediadecodeerror")}.bind(this),1e3)}.bind(this)),mediaManager.defaultOnStop||(mediaManager.defaultOnStop=mediaManager.onStop.bind(mediaManager),mediaManager.onStop=onMediaManagerStop)},BaseHtmlPlayer.prototype.unBindMediaManagerEvents=function(){var mediaManager=window.mediaManager;mediaManager.defaultOnLoad&&(mediaManager.onLoad=mediaManager.defaultOnLoad.bind(mediaManager),mediaManager.defaultOnLoad=null),mediaManager.defaultOnError&&(mediaManager.onError=mediaManager.defaultOnError.bind(mediaManager),mediaManager.defaultOnError=null),mediaManager.defaultOnStop&&(mediaManager.onStop=mediaManager.defaultOnStop.bind(mediaManager),mediaManager.defaultOnStop=null)},BaseHtmlPlayer});